# These functions make a simple approximation for the probability of searching
# that is then used in solution of the model.

# Note: Extra zeros are included because the original model solution programs
#   included x's of the individual and supply groups in this approximation.



### ESTIMATE APPROXIMATIONS
#  (Each fn estimates the approximation then replaces approx. parameters.)

# Fall:

Dpred.Fal <- function(EED.F95, hbar.F95)  {
  #
Dpred.b.F9 <- lm( EED.F95 ~ hbar.F95[,"hbar_b8"], subset = cohort==8 & bio_sex==1)$coef
Dpred.b.F10 <- lm( EED.F95 ~ hbar.F95[,"hbar_b9"], subset = cohort==9 & bio_sex==1)$coef
Dpred.b.F11 <- lm( EED.F95 ~ hbar.F95[,"hbar_b10"], subset = cohort==10 & bio_sex==1)$coef
Dpred.b.F12 <- lm( EED.F95 ~ hbar.F95[,"hbar_b11"], subset = cohort==11 & bio_sex==1)$coef
  #
Dpred.g.F9 <- lm( EED.F95 ~ hbar.F95[,"hbar_g8"], subset = cohort==8 & bio_sex==2)$coef
Dpred.g.F10 <- lm( EED.F95 ~ hbar.F95[,"hbar_g9"], subset = cohort==9 & bio_sex==2)$coef
Dpred.g.F11 <- lm( EED.F95 ~ hbar.F95[,"hbar_g10"], subset = cohort==10 & bio_sex==2)$coef
Dpred.g.F12 <- lm( EED.F95 ~ hbar.F95[,"hbar_g11"], subset = cohort==11 & bio_sex==2)$coef
  #
Dp2.b.F12 <<- Dpred.b.F12[2]; Dpred.b.F12 <<- c(Dpred.b.F12[-2], rep(0,length(indvars)*2) )
Dp2.b.F11 <<- Dpred.b.F11[2]; Dpred.b.F11 <<- c(Dpred.b.F11[-2], rep(0,length(indvars)*2) )
Dp2.b.F10 <<- Dpred.b.F10[2]; Dpred.b.F10 <<- c(Dpred.b.F10[-2], rep(0,length(indvars)*2) )
Dp2.b.F9  <<- Dpred.b.F9[2] ; Dpred.b.F9  <<- c(Dpred.b.F9[-2] , rep(0,length(indvars)*2) )
  #
Dp2.g.F12 <<- Dpred.g.F12[2]; Dpred.g.F12 <<- c(Dpred.g.F12[-2], rep(0,length(indvars)*2) )
Dp2.g.F11 <<- Dpred.g.F11[2]; Dpred.g.F11 <<- c(Dpred.g.F11[-2], rep(0,length(indvars)*2) )
Dp2.g.F10 <<- Dpred.g.F10[2]; Dpred.g.F10 <<- c(Dpred.g.F10[-2], rep(0,length(indvars)*2) )
Dp2.g.F9  <<- Dpred.g.F9[2] ; Dpred.g.F9  <<- c(Dpred.g.F9[-2] , rep(0,length(indvars)*2) )
  }

# Winter:

Dpred.Wtr <- function(EED.W96, hbar.W96)  {
  #
Dpred.b.W9 <- lm( EED.W96 ~ hbar.W96[,"hbar_b9"], subset = cohort==8 & bio_sex==1)$coef
Dpred.b.W10 <- lm( EED.W96 ~ hbar.W96[,"hbar_b10"], subset = cohort==9 & bio_sex==1)$coef
Dpred.b.W11 <- lm( EED.W96 ~ hbar.W96[,"hbar_b11"], subset = cohort==10 & bio_sex==1)$coef
Dpred.b.W12 <- lm( EED.W96 ~ hbar.W96[,"hbar_b12"], subset = cohort==11 & bio_sex==1)$coef
  #
Dpred.g.W9 <- lm( EED.W96 ~ hbar.W96[,"hbar_g9"], subset = cohort==8 & bio_sex==2)$coef
Dpred.g.W10 <- lm( EED.W96 ~ hbar.W96[,"hbar_g10"], subset = cohort==9 & bio_sex==2)$coef
Dpred.g.W11 <- lm( EED.W96 ~ hbar.W96[,"hbar_g11"], subset = cohort==10 & bio_sex==2)$coef
Dpred.g.W12 <- lm( EED.W96 ~ hbar.W96[,"hbar_g12"], subset = cohort==11 & bio_sex==2)$coef
  #
Dp2.b.W12 <<- Dpred.b.W12[2]; Dpred.b.W12 <<- c(Dpred.b.W12[-2], rep(0,length(indvars)*2) )
Dp2.b.W11 <<- Dpred.b.W11[2]; Dpred.b.W11 <<- c(Dpred.b.W11[-2], rep(0,length(indvars)*2) )
Dp2.b.W10 <<- Dpred.b.W10[2]; Dpred.b.W10 <<- c(Dpred.b.W10[-2], rep(0,length(indvars)*2) )
Dp2.b.W9  <<- Dpred.b.W9[2] ; Dpred.b.W9  <<- c(Dpred.b.W9[-2] , rep(0,length(indvars)*2) )
  #
Dp2.g.W12 <<- Dpred.g.W12[2]; Dpred.g.W12 <<- c(Dpred.g.W12[-2], rep(0,length(indvars)*2) )
Dp2.g.W11 <<- Dpred.g.W11[2]; Dpred.g.W11 <<- c(Dpred.g.W11[-2], rep(0,length(indvars)*2) )
Dp2.g.W10 <<- Dpred.g.W10[2]; Dpred.g.W10 <<- c(Dpred.g.W10[-2], rep(0,length(indvars)*2) )
Dp2.g.W9  <<- Dpred.g.W9[2] ; Dpred.g.W9  <<- c(Dpred.g.W9[-2] , rep(0,length(indvars)*2) )
  }

# Spring:

Dpred.Spr <- function(EED.S96, hbar.S96)  {
  #
Dpred.b.S9 <- lm( EED.S96 ~ hbar.S96[,"hbar_b9"], subset = cohort==8 & bio_sex==1)$coef
Dpred.b.S10 <- lm( EED.S96 ~ hbar.S96[,"hbar_b10"], subset = cohort==9 & bio_sex==1)$coef
Dpred.b.S11 <- lm( EED.S96 ~ hbar.S96[,"hbar_b11"], subset = cohort==10 & bio_sex==1)$coef
Dpred.b.S12 <- lm( EED.S96 ~ hbar.S96[,"hbar_b12"], subset = cohort==11 & bio_sex==1)$coef
  #
Dpred.g.S9 <- lm( EED.S96 ~ hbar.S96[,"hbar_g9"], subset = cohort==8 & bio_sex==2)$coef
Dpred.g.S10 <- lm( EED.S96 ~ hbar.S96[,"hbar_g10"], subset = cohort==9 & bio_sex==2)$coef
Dpred.g.S11 <- lm( EED.S96 ~ hbar.S96[,"hbar_g11"], subset = cohort==10 & bio_sex==2)$coef
Dpred.g.S12 <- lm( EED.S96 ~ hbar.S96[,"hbar_g12"], subset = cohort==11 & bio_sex==2)$coef
  #
Dp2.b.S12 <<- Dpred.b.S12[2]; Dpred.b.S12 <<- c(Dpred.b.S12[-2], rep(0,length(indvars)*2) )
Dp2.b.S11 <<- Dpred.b.S11[2]; Dpred.b.S11 <<- c(Dpred.b.S11[-2], rep(0,length(indvars)*2) )
Dp2.b.S10 <<- Dpred.b.S10[2]; Dpred.b.S10 <<- c(Dpred.b.S10[-2], rep(0,length(indvars)*2) )
Dp2.b.S9  <<- Dpred.b.S9[2] ; Dpred.b.S9  <<- c(Dpred.b.S9[-2] , rep(0,length(indvars)*2) )
  #
Dp2.g.S12 <<- Dpred.g.S12[2]; Dpred.g.S12 <<- c(Dpred.g.S12[-2], rep(0,length(indvars)*2) )
Dp2.g.S11 <<- Dpred.g.S11[2]; Dpred.g.S11 <<- c(Dpred.g.S11[-2], rep(0,length(indvars)*2) )
Dp2.g.S10 <<- Dpred.g.S10[2]; Dpred.g.S10 <<- c(Dpred.g.S10[-2], rep(0,length(indvars)*2) )
Dp2.g.S9  <<- Dpred.g.S9[2] ; Dpred.g.S9  <<- c(Dpred.g.S9[-2] , rep(0,length(indvars)*2) )
  }

# Summer:

Dpred.Sum <- function(EED.U95, hbar.U95)  {
  #
Dpred.b.U9 <- lm( EED.U95 ~ hbar.U95[,"hbar_b9"], subset = cohort==9 & bio_sex==1)$coef
Dpred.b.U10 <- lm( EED.U95 ~ hbar.U95[,"hbar_b10"], subset = cohort==10 & bio_sex==1)$coef
Dpred.b.U11 <- lm( EED.U95 ~ hbar.U95[,"hbar_b11"], subset = cohort==11 & bio_sex==1)$coef
  #
Dpred.g.U9 <- lm( EED.U95 ~ hbar.U95[,"hbar_g9"], subset = cohort==9 & bio_sex==2)$coef
Dpred.g.U10 <- lm( EED.U95 ~ hbar.U95[,"hbar_g10"], subset = cohort==10 & bio_sex==2)$coef
Dpred.g.U11 <- lm( EED.U95 ~ hbar.U95[,"hbar_g11"], subset = cohort==11 & bio_sex==2)$coef
  #
Dp2.b.U11 <<- Dpred.b.U11[2]; Dpred.b.U11 <<- c(Dpred.b.U11[-2], rep(0,length(indvars)*2) )
Dp2.b.U10 <<- Dpred.b.U10[2]; Dpred.b.U10 <<- c(Dpred.b.U10[-2], rep(0,length(indvars)*2) )
Dp2.b.U9  <<- Dpred.b.U9[2] ; Dpred.b.U9  <<- c(Dpred.b.U9[-2] , rep(0,length(indvars)*2) )
  #
Dp2.g.U11 <<- Dpred.g.U11[2]; Dpred.g.U11 <<- c(Dpred.g.U11[-2], rep(0,length(indvars)*2) )
Dp2.g.U10 <<- Dpred.g.U10[2]; Dpred.g.U10 <<- c(Dpred.g.U10[-2], rep(0,length(indvars)*2) )
Dp2.g.U9  <<- Dpred.g.U9[2] ; Dpred.g.U9  <<- c(Dpred.g.U9[-2] , rep(0,length(indvars)*2) )
  }
