# These functions compute the difference in the value functions (V1 - V0).
# This gives the threshold in epsilon that determines the search decision.



### VALUE DIFF FUNCTIONS

# Ninth grade:

Vdiff.b.F9 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b9] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b9]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b9] <- Eh0.b[,p.b9] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b10]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b); E10h.b <- psi.qtr(E9h.b); E11h.b <- psi.qtr(E10h.b)
E12h.b <- psi.ann(E8h.b); E13h.b <- psi.qtr(E12h.b); E14h.b <- psi.qtr(E13h.b)
  BEV0 <- B*cbind( EV0hat.b.W9(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.W9(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.W9(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  (1+B+B^2+B^3)*a.b9 + sum(B^(4:7))*a.b10 + sum(B^(8:11))*a.b11 + sum(B^(12:14))*a.b12 +
  a1.b*(sum(B^(0:14)*(1:15)) + B^15*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] + B*Eh.b[,p.b9] + B^2*E2h.b[,p.b9] + B^3*E3h.b[,p.b9] 
         + B^4*E4h.b[,p.b10] + B^5*E5h.b[,p.b10] + B^6*E6h.b[,p.b10] + B^7*E7h.b[,p.b10] 
         + B^8*E8h.b[,p.b11] + B^9*E9h.b[,p.b11] + B^10*E10h.b[,p.b11] + B^11*E11h.b[,p.b11] 
         + B^12*E12h.b[,p.b12] + B^13*E13h.b[,p.b12] + B^14*E14h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.F9 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g9] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g9]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g9] <- Eh0.g[,p.g9] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g); E10h.g <- psi.qtr(E9h.g); E11h.g <- psi.qtr(E10h.g)
E12h.g <- psi.ann(E8h.g); E13h.g <- psi.qtr(E12h.g); E14h.g <- psi.qtr(E13h.g)
  BEV0 <- B*cbind( EV0hat.g.W9(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.W9(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.W9(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  (1+B+B^2+B^3)*a.g9 + sum(B^(4:7))*a.g10 + sum(B^(8:11))*a.g11 + sum(B^(12:14))*a.g12 +
  a1.g*(sum(B^(0:14)*(1:15)) + B^15*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] + B*Eh.g[,p.g9] + B^2*E2h.g[,p.g9] + B^3*E3h.g[,p.g9] 
         + B^4*E4h.g[,p.g10] + B^5*E5h.g[,p.g10] + B^6*E6h.g[,p.g10] + B^7*E7h.g[,p.g10] 
         + B^8*E8h.g[,p.g11] + B^9*E9h.g[,p.g11] + B^10*E10h.g[,p.g11] + B^11*E11h.g[,p.g11] 
         + B^12*E12h.g[,p.g12] + B^13*E13h.g[,p.g12] + B^14*E14h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.W9 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b9] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b9]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b9] <- Eh0.b[,p.b9] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.chg(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b10]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.chg(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b); E10h.b <- psi.qtr(E9h.b); E11h.b <- psi.chg(E10h.b)
E12h.b <- psi.ann(E8h.b); E13h.b <- psi.qtr(E12h.b)
  BEV0 <- B*cbind( EV0hat.b.S9(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl), 
    EV0hat.b.S9(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.S9(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  (1+B+B^2)*a.b9 + sum(B^(3:6))*a.b10 + sum(B^(7:10))*a.b11 + sum(B^(11:13))*a.b12 +
  a1.b*(sum(B^(0:13)*(2:15)) + B^14*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] + B*Eh.b[,p.b9] + B^2*E2h.b[,p.b9] 
         + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] + B^5*E5h.b[,p.b10] + B^6*E6h.b[,p.b10] 
         + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] + B^9*E9h.b[,p.b11] + B^10*E10h.b[,p.b11] 
         + B^11*E11h.b[,p.b12] + B^12*E12h.b[,p.b12] + B^13*E13h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.W9 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g9] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g9]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g9] <- Eh0.g[,p.g9] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.chg(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.chg(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g); E10h.g <- psi.qtr(E9h.g); E11h.g <- psi.chg(E10h.g)
E12h.g <- psi.ann(E8h.g); E13h.g <- psi.qtr(E12h.g)
  BEV0 <- B*cbind( EV0hat.g.S9(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.S9(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.S9(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  (1+B+B^2)*a.g9 + sum(B^(3:6))*a.g10 + sum(B^(7:10))*a.g11 + sum(B^(11:13))*a.g12 +
  a1.g*(sum(B^(0:13)*(2:15)) + B^14*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] + B*Eh.g[,p.g9] + B^2*E2h.g[,p.g9] 
         + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] + B^5*E5h.g[,p.g10] + B^6*E6h.g[,p.g10] 
         + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] + B^9*E9h.g[,p.g11] + B^10*E10h.g[,p.g11] 
         + B^11*E11h.g[,p.g12] + B^12*E12h.g[,p.g12] + B^13*E13h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.S9 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b9] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b9]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b9] <- Eh0.b[,p.b9] + 1/pop.Pb;           E2h.b <- psi.chg(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b10]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.chg(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b); E10h.b <- psi.chg(E9h.b); E11h.b <- psi.qtr(E10h.b)
E12h.b <- psi.ann(E8h.b)
  BEV0 <- B*cbind( EV0hat.b.U9(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.U9(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.U9(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  (1+B)*a.b9 + sum(B^(2:5))*a.b10 + sum(B^(6:9))*a.b11 + sum(B^(10:12))*a.b12 +
  a1.b*(sum(B^(0:12)*(3:15)) + B^13*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] + B*Eh.b[,p.b9] 
         + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] + B^5*E5h.b[,p.b10] 
         + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] + B^9*E9h.b[,p.b11] 
         + B^10*E10h.b[,p.b12] + B^11*E11h.b[,p.b12] + B^12*E12h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.S9 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g9] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g9]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g9] <- Eh0.g[,p.g9] + 1/pop.Pg;           E2h.g <- psi.chg(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.chg(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g); E10h.g <- psi.chg(E9h.g); E11h.g <- psi.qtr(E10h.g)
E12h.g <- psi.ann(E8h.g)
  BEV0 <- B*cbind( EV0hat.g.U9(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.U9(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.U9(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  (1+B)*a.g9 + sum(B^(2:5))*a.g10 + sum(B^(6:9))*a.g11 + sum(B^(10:12))*a.g12 +
  a1.g*(sum(B^(0:12)*(3:15)) + B^13*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] + B*Eh.g[,p.g9] 
         + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] + B^5*E5h.g[,p.g10] 
         + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] + B^9*E9h.g[,p.g11] 
         + B^10*E10h.g[,p.g12] + B^11*E11h.g[,p.g12] + B^12*E12h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.U9 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b10] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b10]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b10] <- Eh0.b[,p.b10] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b9]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.chg(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.chg(E8h.b); E10h.b <- psi.qtr(E9h.b); E11h.b <- psi.qtr(E10h.b)
  BEV0 <- B*cbind( EV0hat.b.F10(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl), 
    EV0hat.b.F10(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.F10(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  a.b9 + sum(B^(1:4))*a.b10 + sum(B^(5:8))*a.b11 + sum(B^(9:11))*a.b12 +
  a1.b*(sum(B^(0:11)*(4:15)) + B^12*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] 
         + B*Eh.b[,p.b10] + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] 
         + B^5*E5h.b[,p.b11] + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] 
         + B^9*E9h.b[,p.b12] + B^10*E10h.b[,p.b12] + B^11*E11h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.U9 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g10] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g10]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g10] <- Eh0.g[,p.g10] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.chg(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.chg(E8h.g); E10h.g <- psi.qtr(E9h.g); E11h.g <- psi.qtr(E10h.g)
  BEV0 <- B*cbind( EV0hat.g.F10(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.F10(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.F10(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  a.g9 + sum(B^(1:4))*a.g10 + sum(B^(5:8))*a.g11 + sum(B^(9:11))*a.g12 +
  a1.g*(sum(B^(0:11)*(4:15)) + B^12*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] 
         + B*Eh.g[,p.g10] + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] 
         + B^5*E5h.g[,p.g11] + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] 
         + B^9*E9h.g[,p.g12] + B^10*E10h.g[,p.g12] + B^11*E11h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }



# Tenth grade:

Vdiff.b.F10 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b10] <- h.b[,p.b10]/pop.Pb + Eh.b[,p.b10]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b10] <- Eh0.b[,p.b10] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b11] <- (h.b[,p.b10]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b); E10h.b <- psi.qtr(E9h.b)
  BEV0 <- B*cbind( EV0hat.b.W10(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.W10(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.W10(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  sum(B^(0:3))*a.b10 + sum(B^(4:7))*a.b11 + sum(B^(8:10))*a.b12 +
  a1.b*(sum(B^(0:10)*(5:15)) + B^11*16/(1-B))/10 +
  g.b * ( h.b[,p.b10] + B*Eh.b[,p.b10] + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] 
         + B^4*E4h.b[,p.b11] + B^5*E5h.b[,p.b11] + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] 
         + B^8*E8h.b[,p.b12] + B^9*E9h.b[,p.b12] + B^10*E10h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.F10 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g10] <- h.g[,p.g10]/pop.Pg + Eh.g[,p.g10]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g10] <- Eh0.g[,p.g10] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g11] <- (h.g[,p.g10]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g); E10h.g <- psi.qtr(E9h.g)
  BEV0 <- B*cbind( EV0hat.g.W10(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.W10(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.W10(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  sum(B^(0:3))*a.g10 + sum(B^(4:7))*a.g11 + sum(B^(8:10))*a.g12 +
  a1.g*(sum(B^(0:10)*(5:15)) + B^11*16/(1-B))/10 +
  g.g * ( h.g[,p.g10] + B*Eh.g[,p.g10] + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] 
         + B^4*E4h.g[,p.g11] + B^5*E5h.g[,p.g11] + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] 
         + B^8*E8h.g[,p.g12] + B^9*E9h.g[,p.g12] + B^10*E10h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.W10 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b10] <- h.b[,p.b10]/pop.Pb + Eh.b[,p.b10]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b10] <- Eh0.b[,p.b10] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.chg(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b11] <- (h.b[,p.b10]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.chg(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b)
  BEV0 <- B*cbind( EV0hat.b.S10(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.S10(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.S10(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  sum(B^(0:2))*a.b10 + sum(B^(3:6))*a.b11 + sum(B^(7:9))*a.b12 +
  a1.b*(sum(B^(0:9)*(6:15)) + B^10*16/(1-B))/10 +
  g.b * ( h.b[,p.b10] + B*Eh.b[,p.b10] + B^2*E2h.b[,p.b10] 
         + B^3*E3h.b[,p.b11] + B^4*E4h.b[,p.b11] + B^5*E5h.b[,p.b11] + B^6*E6h.b[,p.b11] 
         + B^7*E7h.b[,p.b12] + B^8*E8h.b[,p.b12] + B^9*E9h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.W10 <- function (W,  h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g10] <- h.g[,p.g10]/pop.Pg + Eh.g[,p.g10]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g10] <- Eh0.g[,p.g10] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.chg(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g11] <- (h.g[,p.g10]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.chg(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g)
  BEV0 <- B*cbind( EV0hat.g.S10(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.S10(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.S10(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  sum(B^(0:2))*a.g10 + sum(B^(3:6))*a.g11 + sum(B^(7:9))*a.g12 +
  a1.g*(sum(B^(0:9)*(6:15)) + B^10*16/(1-B))/10 +
  g.g * ( h.g[,p.g10] + B*Eh.g[,p.g10] + B^2*E2h.g[,p.g10] 
         + B^3*E3h.g[,p.g11] + B^4*E4h.g[,p.g11] + B^5*E5h.g[,p.g11] + B^6*E6h.g[,p.g11] 
         + B^7*E7h.g[,p.g12] + B^8*E8h.g[,p.g12] + B^9*E9h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.S10 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b10] <- h.b[,p.b10]/pop.Pb + Eh.b[,p.b10]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b10] <- Eh0.b[,p.b10] + 1/pop.Pb;           E2h.b <- psi.chg(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b11] <- (h.b[,p.b10]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.chg(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b)
  BEV0 <- B*cbind( EV0hat.b.U10(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.U10(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.U10(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
  (1+B)*a.b10 + sum(B^(2:5))*a.b11 + sum(B^(6:8))*a.b12 +
  a1.b*(sum(B^(0:8)*(7:15)) + B^9*16/(1-B))/10 +
  g.b * ( h.b[,p.b10] + B*Eh.b[,p.b10] 
         + B^2*E2h.b[,p.b11] + B^3*E3h.b[,p.b11] + B^4*E4h.b[,p.b11] + B^5*E5h.b[,p.b12] 
         + B^6*E6h.b[,p.b12] + B^7*E7h.b[,p.b12] + B^8*E8h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.S10 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g10] <- h.g[,p.g10]/pop.Pg + Eh.g[,p.g10]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g10] <- Eh0.g[,p.g10] + 1/pop.Pg;           E2h.g <- psi.chg(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g11] <- (h.g[,p.g10]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.chg(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g)
  BEV0 <- B*cbind( EV0hat.g.U10(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.U10(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.U10(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
  (1+B)*a.g10 + sum(B^(2:5))*a.g11 + sum(B^(6:8))*a.g12 +
  a1.g*(sum(B^(0:8)*(7:15)) + B^9*16/(1-B))/10 +
  g.g * ( h.g[,p.g10] + B*Eh.g[,p.g10]
         + B^2*E2h.g[,p.g11] + B^3*E3h.g[,p.g11] + B^4*E4h.g[,p.g11] + B^5*E5h.g[,p.g11] 
         + B^6*E6h.g[,p.g12] + B^7*E7h.g[,p.g12] + B^8*E8h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.U10 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b11] <- h.b[,p.b10]/pop.Pb + Eh.b[,p.b11]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b11] <- Eh0.b[,p.b11] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b11] <- (h.b[,p.b10]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.chg(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
  BEV0 <- B*cbind( EV0hat.b.F11(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.F11(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.F11(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
    a.b10 + sum(B^(1:4))*a.b11 + sum(B^(5:7))*a.b12 +
  a1.b*(sum(B^(0:7)*(8:15)) + B^8*16/(1-B))/10 +
  g.b * ( h.b[,p.b10] 
         + B*Eh.b[,p.b11] + B^2*E2h.b[,p.b11] + B^3*E3h.b[,p.b11] + B^4*E4h.b[,p.b11] 
         + B^5*E5h.b[,p.b12] + B^6*E6h.b[,p.b12] + B^7*E7h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.U10 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g11] <- h.g[,p.g10]/pop.Pg + Eh.g[,p.g11]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g11] <- Eh0.g[,p.g11] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g11] <- (h.g[,p.g10]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.chg(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
  BEV0 <- B*cbind( EV0hat.g.F11(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.F11(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.F11(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
    a.g10 + sum(B^(1:4))*a.g11 + sum(B^(5:7))*a.g12 +
  a1.g*(sum(B^(0:7)*(8:15)) + B^8*16/(1-B))/10 +
  g.g * ( h.g[,p.g10] 
         + B*Eh.g[,p.g11] + B^2*E2h.g[,p.g11] + B^3*E3h.g[,p.g11] + B^4*E4h.g[,p.g11] 
         + B^5*E5h.g[,p.g12] + B^6*E6h.g[,p.g12] + B^7*E7h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }



# Eleventh grade:

Vdiff.b.F11 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b11] <- h.b[,p.b11]/pop.Pb + Eh.b[,p.b11]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b11] <- Eh0.b[,p.b11] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b12] <- (h.b[,p.b11]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.qtr(E5h.b)
  BEV0 <- B*cbind( EV0hat.b.W11(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.W11(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.W11(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
    sum(B^(0:3))*a.b11 + sum(B^(4:6))*a.b12 + a1.b*(sum(B^(0:6)*(9:15)) + B^7*16/(1-B))/10 +
    g.b * ( h.b[,p.b11] + B*Eh.b[,p.b11] + B^2*E2h.b[,p.b11] + B^3*E3h.b[,p.b11]
           + B^4*E4h.b[,p.b12] + B^5*E5h.b[,p.b12] + B^6*E6h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.F11 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g11] <- h.g[,p.g11]/pop.Pg + Eh.g[,p.g11]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g11] <- Eh0.g[,p.g11] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g12] <- (h.g[,p.g11]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.qtr(E5h.g)
  BEV0 <- B*cbind( EV0hat.g.W11(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.W11(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.W11(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
    sum(B^(0:3))*a.g11 + sum(B^(4:6))*a.g12 + a1.g*(sum(B^(0:6)*(9:15)) + B^7*16/(1-B))/10 +
    g.g * ( h.g[,p.g11] + B*Eh.g[,p.g11] + B^2*E2h.g[,p.g11] + B^3*E3h.g[,p.g11] 
           + B^4*E4h.g[,p.g12] + B^5*E5h.g[,p.g12] + B^6*E6h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.W11 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b11] <- h.b[,p.b11]/pop.Pb + Eh.b[,p.b11]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b11] <- Eh0.b[,p.b11] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.chg(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b12] <- (h.b[,p.b11]+1)/pop.Pb + E4h.b[,p.b12]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b)
  BEV0 <- B*cbind( EV0hat.b.S11(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.S11(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.S11(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
    sum(B^(0:2))*a.b11 + sum(B^(3:5))*a.b12 + a1.b*(sum(B^(0:5)*(10:15)) + B^6*16/(1-B))/10 +
    g.b * ( h.b[,p.b11] + B*Eh.b[,p.b11] + B^2*E2h.b[,p.b11] 
           + B^3*E3h.b[,p.b12] + B^4*E4h.b[,p.b12] + B^5*E5h.b[,p.b12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.W11 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g11] <- h.g[,p.g11]/pop.Pg + Eh.g[,p.g11]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g11] <- Eh0.g[,p.g11] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.chg(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g12] <- (h.g[,p.g11]+1)/pop.Pg + E4h.g[,p.g12]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g)
  BEV0 <- B*cbind( EV0hat.g.S11(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.S11(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.S11(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
    sum(B^(0:2))*a.g11 + sum(B^(3:5))*a.g12 + a1.g*(sum(B^(0:5)*(10:15)) + B^6*16/(1-B))/10 +
    g.g * ( h.g[,p.g11] + B*Eh.g[,p.g11] + B^2*E2h.g[,p.g11] 
         + B^3*E3h.g[,p.g12] + B^4*E4h.g[,p.g12] + B^5*E5h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.S11 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b11] <- h.b[,p.b11]/pop.Pb + Eh.b[,p.b11]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b11] <- Eh0.b[,p.b11] + 1/pop.Pb;           E2h.b <- psi.chg(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b12] <- (h.b[,p.b11]+1)/pop.Pb + E4h.b[,p.b12]*(pop.Pb-1)/pop.Pb
  BEV0 <- B*cbind( EV0hat.b.U11(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.U11(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.U11(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
    (1+B)*a.b11 + sum(B^(2:4))*a.b12 + a1.b*(sum(B^(0:4)*(11:15)) + B^5*16/(1-B))/10 +
    g.b * ( h.b[,p.b11] + B*Eh.b[,p.b11] 
           + B^2*E2h.b[,p.b12] + B^3*E3h.b[,p.b12] + B^4*E4h.b[,p.b12] )  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.S11 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g11] <- h.g[,p.g11]/pop.Pg + Eh.g[,p.g11]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g11] <- Eh0.g[,p.g11] + 1/pop.Pg;           E2h.g <- psi.chg(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g12] <- (h.g[,p.g11]+1)/pop.Pg + E4h.g[,p.g12]*(pop.Pg-1)/pop.Pg
  BEV0 <- B*cbind( EV0hat.g.U11(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.U11(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.U11(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
    (1+B)*a.g11 + sum(B^(2:4))*a.g12 + a1.g*(sum(B^(0:4)*(11:15)) + B^5*16/(1-B))/10 +
    g.g * ( h.g[,p.g11] + B*Eh.g[,p.g11] 
           + B^2*E2h.g[,p.g12] + B^3*E3h.g[,p.g12] + B^4*E4h.g[,p.g12] )  ) 
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.U11 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b12] <- h.b[,p.b11]/pop.Pb + Eh.b[,p.b12]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b12] <- Eh0.b[,p.b12] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
  BEV0 <- B*cbind( EV0hat.b.F12(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.F12(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.F12(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
    a.b11 + sum(B^(1:3))*a.b12 + a1.b*(sum(B^(0:3)*(12:15)) + B^4*16/(1-B))/10 +
    g.b * (h.b[,p.b11] + B*Eh.b[,p.b12] + B^2*E2h.b[,p.b12] + B^3*E3h.b[,p.b12])  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.U11 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g12] <- h.g[,p.g11]/pop.Pg + Eh.g[,p.g12]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g12] <- Eh0.g[,p.g12] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
  BEV0 <- B*cbind( EV0hat.g.F12(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.F12(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.F12(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
    a.g11 + sum(B^(1:3))*a.g12 + a1.g*(sum(B^(0:3)*(12:15)) + B^4*16/(1-B))/10 +
    g.g * (h.g[,p.g11] + B*Eh.g[,p.g12] + B^2*E2h.g[,p.g12] + B^3*E3h.g[,p.g12])  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }



# Twelfth grade:

Vdiff.b.F12 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b12] <- h.b[,p.b12]/pop.Pb + Eh.b[,p.b12]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b12] <- Eh0.b[,p.b12] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b)
  BEV0 <-B*cbind( EV0hat.b.W12(W[1], Eh0.b, Xbar.m, pop.Pb, nosupl),
    EV0hat.b.W12(W[2], Eh0.b, Xbar.m, pop.Pb, nosupl), EV0hat.b.W12(W[3], Eh0.b, Xbar.m, pop.Pb, nosupl) )
  V1obs <- as.vector(
   (1+B+B^2)*a.b12 + a1.b*(sum(B^(0:2)*(13:15)) + B^3*16/(1-B))/10 +
    g.b * (h.b[,p.b12] + B*Eh.b[,p.b12] + B^2*E2h.b[,p.b12])  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.F12 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g12] <- h.g[,p.g12]/pop.Pg + Eh.g[,p.g12]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g12] <- Eh0.g[,p.g12] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g)
  BEV0 <- B*cbind( EV0hat.g.W12(W[1], Eh0.g, Xbar.m, pop.Pg, nosupl),
    EV0hat.g.W12(W[2], Eh0.g, Xbar.m, pop.Pg, nosupl), EV0hat.g.W12(W[3], Eh0.g, Xbar.m, pop.Pg, nosupl) )
  V1obs <- as.vector(
   (1+B+B^2)*a.g12 + a1.g*(sum(B^(0:2)*(13:15)) + B^3*16/(1-B))/10 +
    g.g * (h.g[,p.g12] + B*Eh.g[,p.g12] + B^2*E2h.g[,p.g12])  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.W12 <- function (W, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b12] <- h.b[,p.b12]/pop.Pb + Eh.b[,p.b12]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b12] <- Eh0.b[,p.b12] + 1/pop.Pb
  BEV0 <- B*cbind( EV0hat.b.S12(W[1], Eh0.b, Xbar.m, nosupl),
    EV0hat.b.S12(W[2], Eh0.b, Xbar.m, nosupl), EV0hat.b.S12(W[3], Eh0.b, Xbar.m, nosupl) )
  V1obs <- as.vector(
   (1+B)*a.b12 + a1.b*(sum(B^(0:1)*(14:15)) + B^2*16/(1-B))/10 +
    g.b * (h.b[,p.b12] + B*Eh.b[,p.b12])  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.W12 <- function (W, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g12] <- h.g[,p.g12]/pop.Pg + Eh.g[,p.g12]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g12] <- Eh0.g[,p.g12] + 1/pop.Pg
  BEV0 <- B*cbind( EV0hat.g.S12(W[1], Eh0.g, Xbar.m, nosupl),
    EV0hat.g.S12(W[2], Eh0.g, Xbar.m, nosupl), EV0hat.g.S12(W[3], Eh0.g, Xbar.m, nosupl) )
  V1obs <- as.vector(
   (1+B)*a.g12 + a1.g*(sum(B^(0:1)*(14:15)) + B^2*16/(1-B))/10 +
    g.g * (h.g[,p.g12] + B*Eh.g[,p.g12])  )
  V1obs - BEV0 + (1/(1-B))*matrix(W, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.b.S12 <- function (W, h, Xbar.m, nosupl)  {
  V1obs <- as.vector( a.b12 + a1.b*(1.5 + B*1.6/(1-B)) + g.b*h[,p.b12]  )
  V1obs + matrix(W/(1-B) - B*v.b, nrow(Xbar.m), length(W), byrow=TRUE)
  }

Vdiff.g.S12 <- function (W, h, Xbar.m, nosupl)  {
  V1obs <- as.vector( a.g12 + a1.g*(1.5 + B*1.6/(1-B)) + g.g*h[,p.g12]  )
  V1obs + matrix(W/(1-B) - B*v.g, nrow(Xbar.m), length(W), byrow=TRUE)
  }
