# Report estimates of marginal social effects on search decisions and arrival rates.

# Before running this program, first run the code for section 3
# from the function like.sml (in likeli_SML.R), in the global environment.
# This produces the objects Elam.xxx needed below.

# Also, note that like.sml already assigns PI (type prob's) in the global environment.



### PEER PREFERENCE INTERACTION

# Storage:

temp.marg <- matrix(nrow=4,ncol=2)

# A) Boys

# 9th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.b.F9(W.b, h.b9.F94 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b9.F94),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.F94,], pop.Pb9[vov.b9.F94], nosupply.b9a[vov.b9.F94,]) )
  - pnorm( Vdiff.b.F9(W.b, h.b9.F94, Xbar.Mb9[vov.b9.F94,], pop.Pb9[vov.b9.F94], nosupply.b9a[vov.b9.F94,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.F94],] ),
rowSums(
( pnorm( Vdiff.b.F9(W.b, h.b8.F95 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b8.F95),ncol=8, byrow=T),
      Xbar.Mb8[vov.b8.F95,], pop.Pb8[vov.b8.F95], nosupply.b8[vov.b8.F95,]) )
  - pnorm( Vdiff.b.F9(W.b, h.b8.F95, Xbar.Mb8[vov.b8.F95,], pop.Pb8[vov.b8.F95], nosupply.b8[vov.b8.F95,]) )
) / 1e-5 * PI[virgins.b8[vov.b8.F95],] ), 
rowSums(
( pnorm( Vdiff.b.W9(W.b, h.b9.W95 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b9.W95),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.W95,], pop.Pb9[vov.b9.W95], nosupply.b9a[vov.b9.W95,]) )
  - pnorm( Vdiff.b.W9(W.b, h.b9.W95, Xbar.Mb9[vov.b9.W95,], pop.Pb9[vov.b9.W95], nosupply.b9a[vov.b9.W95,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.W95],] ),
rowSums(
( pnorm( Vdiff.b.W9(W.b, h.b8.W96 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b8.W96),ncol=8, byrow=T),
      Xbar.Mb8[vov.b8.W96,], pop.Pb8[vov.b8.W96], nosupply.b8[vov.b8.W96,]) )
  - pnorm( Vdiff.b.W9(W.b, h.b8.W96, Xbar.Mb8[vov.b8.W96,], pop.Pb8[vov.b8.W96], nosupply.b8[vov.b8.W96,]) )
) / 1e-5 * PI[virgins.b8[vov.b8.W96],] ), 
rowSums(
( pnorm( Vdiff.b.S9(W.b, h.b9.S95 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b9.S95),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.S95,], pop.Pb9[vov.b9.S95], nosupply.b9a[vov.b9.S95,]) )
  - pnorm( Vdiff.b.S9(W.b, h.b9.S95, Xbar.Mb9[vov.b9.S95,], pop.Pb9[vov.b9.S95], nosupply.b9a[vov.b9.S95,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.S95],] ),
rowSums(
( pnorm( Vdiff.b.S9(W.b, h.b8.S96 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b8.S96),ncol=8, byrow=T),
      Xbar.Mb8[vov.b8.S96,], pop.Pb8[vov.b8.S96], nosupply.b8[vov.b8.S96,]) )
  - pnorm( Vdiff.b.S9(W.b, h.b8.S96, Xbar.Mb8[vov.b8.S96,], pop.Pb8[vov.b8.S96], nosupply.b8[vov.b8.S96,]) )
) / 1e-5 * PI[virgins.b8[vov.b8.S96],] ), 
rowSums(
( pnorm( Vdiff.b.U9(W.b, h.b9.U95 + matrix(c(1e-5,0,0,0,0,0,0,0), nrow=length(vov.b9.U95),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.U95,], pop.Pb9[vov.b9.U95], nosupply.b9a[vov.b9.U95,]) )
  - pnorm( Vdiff.b.U9(W.b, h.b9.U95, Xbar.Mb9[vov.b9.U95,], pop.Pb9[vov.b9.U95], nosupply.b9a[vov.b9.U95,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.U95],] )
  ) ) -> temp.marg[1,1]

# 10th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.b.F10(W.b, h.b10.F94 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b10.F94),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.F94,], pop.Pb10[vov.b10.F94], nosupply.b10a[vov.b10.F94,]) )
  - pnorm( Vdiff.b.F10(W.b, h.b10.F94, Xbar.Mb10[vov.b10.F94,], pop.Pb10[vov.b10.F94], nosupply.b10a[vov.b10.F94,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.F94],] ),
rowSums(
( pnorm( Vdiff.b.F10(W.b, h.b9.F95 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b9.F95),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.F95,], pop.Pb9[vov.b9.F95], nosupply.b9[vov.b9.F95,]) )
  - pnorm( Vdiff.b.F10(W.b, h.b9.F95, Xbar.Mb9[vov.b9.F95,], pop.Pb9[vov.b9.F95], nosupply.b9[vov.b9.F95,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.F95],] ),
rowSums(
( pnorm( Vdiff.b.W10(W.b, h.b10.W95 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b10.W95),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.W95,], pop.Pb10[vov.b10.W95], nosupply.b10a[vov.b10.W95,]) )
  - pnorm( Vdiff.b.W10(W.b, h.b10.W95, Xbar.Mb10[vov.b10.W95,], pop.Pb10[vov.b10.W95], nosupply.b10a[vov.b10.W95,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.W95],] ),
rowSums(
( pnorm( Vdiff.b.W10(W.b, h.b9.W96 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b9.W96),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.W96,], pop.Pb9[vov.b9.W96], nosupply.b9[vov.b9.W96,]) )
  - pnorm( Vdiff.b.W10(W.b, h.b9.W96, Xbar.Mb9[vov.b9.W96,], pop.Pb9[vov.b9.W96], nosupply.b9[vov.b9.W96,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.W96],] ),
rowSums(
( pnorm( Vdiff.b.S10(W.b, h.b10.S95 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b10.S95),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.S95,], pop.Pb10[vov.b10.S95], nosupply.b10a[vov.b10.S95,]) )
  - pnorm( Vdiff.b.S10(W.b, h.b10.S95, Xbar.Mb10[vov.b10.S95,], pop.Pb10[vov.b10.S95], nosupply.b10a[vov.b10.S95,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.S95],] ),
rowSums(
( pnorm( Vdiff.b.S10(W.b, h.b9.S96 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b9.S96),ncol=8, byrow=T),
      Xbar.Mb9[vov.b9.S96,], pop.Pb9[vov.b9.S96], nosupply.b9[vov.b9.S96,]) )
  - pnorm( Vdiff.b.S10(W.b, h.b9.S96, Xbar.Mb9[vov.b9.S96,], pop.Pb9[vov.b9.S96], nosupply.b9[vov.b9.S96,]) )
) / 1e-5 * PI[virgins.b9[vov.b9.S96],] ),
rowSums(
( pnorm( Vdiff.b.U10(W.b, h.b10.U95 + matrix(c(0,1e-5,0,0,0,0,0,0), nrow=length(vov.b10.U95),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.U95,], pop.Pb10[vov.b10.U95], nosupply.b10a[vov.b10.U95,]) )
  - pnorm( Vdiff.b.U10(W.b, h.b10.U95, Xbar.Mb10[vov.b10.U95,], pop.Pb10[vov.b10.U95], nosupply.b10a[vov.b10.U95,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.U95],] )
  ) ) -> temp.marg[2,1]

# 11th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.b.F11(W.b, h.b11.F94 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b11.F94),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.F94,], pop.Pb11[vov.b11.F94], nosupply.b11[vov.b11.F94,]) )
  - pnorm( Vdiff.b.F11(W.b, h.b11.F94, Xbar.Mb11[vov.b11.F94,], pop.Pb11[vov.b11.F94], nosupply.b11[vov.b11.F94,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.F94],] ),
rowSums(
( pnorm( Vdiff.b.F11(W.b, h.b10.F95 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b10.F95),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.F95,], pop.Pb10[vov.b10.F95], nosupply.b10[vov.b10.F95,]) )
  - pnorm( Vdiff.b.F11(W.b, h.b10.F95, Xbar.Mb10[vov.b10.F95,], pop.Pb10[vov.b10.F95], nosupply.b10[vov.b10.F95,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.F95],] ),
rowSums(
( pnorm( Vdiff.b.W11(W.b, h.b11.W95 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b11.W95),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.W95,], pop.Pb11[vov.b11.W95], nosupply.b11[vov.b11.W95,]) )
  - pnorm( Vdiff.b.W11(W.b, h.b11.W95, Xbar.Mb11[vov.b11.W95,], pop.Pb11[vov.b11.W95], nosupply.b11[vov.b11.W95,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.W95],] ),
rowSums(
( pnorm( Vdiff.b.W11(W.b, h.b10.W96 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b10.W96),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.W96,], pop.Pb10[vov.b10.W96], nosupply.b10[vov.b10.W96,]) )
  - pnorm( Vdiff.b.W11(W.b, h.b10.W96, Xbar.Mb10[vov.b10.W96,], pop.Pb10[vov.b10.W96], nosupply.b10[vov.b10.W96,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.W96],] ),
rowSums(
( pnorm( Vdiff.b.S11(W.b, h.b11.S95 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b11.S95),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.S95,], pop.Pb11[vov.b11.S95], nosupply.b11[vov.b11.S95,]) )
  - pnorm( Vdiff.b.S11(W.b, h.b11.S95, Xbar.Mb11[vov.b11.S95,], pop.Pb11[vov.b11.S95], nosupply.b11[vov.b11.S95,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.S95],] ),
rowSums(
( pnorm( Vdiff.b.S11(W.b, h.b10.S96 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b10.S96),ncol=8, byrow=T),
      Xbar.Mb10[vov.b10.S96,], pop.Pb10[vov.b10.S96], nosupply.b10[vov.b10.S96,]) )
  - pnorm( Vdiff.b.S11(W.b, h.b10.S96, Xbar.Mb10[vov.b10.S96,], pop.Pb10[vov.b10.S96], nosupply.b10[vov.b10.S96,]) )
) / 1e-5 * PI[virgins.b10[vov.b10.S96],] ),
rowSums(
( pnorm( Vdiff.b.U11(W.b, h.b11.U95 + matrix(c(0,0,1e-5,0,0,0,0,0), nrow=length(vov.b11.U95),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.U95,], pop.Pb11[vov.b11.U95], nosupply.b11[vov.b11.U95,]) )
  - pnorm( Vdiff.b.U11(W.b, h.b11.U95, Xbar.Mb11[vov.b11.U95,], pop.Pb11[vov.b11.U95], nosupply.b11[vov.b11.U95,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.U95],] )
  ) ) -> temp.marg[3,1]

# 12th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.b.F12(W.b, h.b12.F94 + matrix(c(0,0,0,1e-5,0,0,0,0), nrow=length(vov.b12.F94),ncol=8, byrow=T),
      Xbar.Mb12[vov.b12.F94,], pop.Pb12[vov.b12.F94], nosupply.b12[vov.b12.F94,]) )
  - pnorm( Vdiff.b.F12(W.b, h.b12.F94, Xbar.Mb12[vov.b12.F94,], pop.Pb12[vov.b12.F94], nosupply.b12[vov.b12.F94,]) )
) / 1e-5 * PI[virgins.b12[vov.b12.F94],] ),
rowSums(
( pnorm( Vdiff.b.F12(W.b, h.b11.F95 + matrix(c(0,0,0,1e-5,0,0,0,0), nrow=length(vov.b11.F95),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.F95,], pop.Pb11[vov.b11.F95], nosupply.b11[vov.b11.F95,]) )
  - pnorm( Vdiff.b.F12(W.b, h.b11.F95, Xbar.Mb11[vov.b11.F95,], pop.Pb11[vov.b11.F95], nosupply.b11[vov.b11.F95,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.F95],] ),
rowSums(
( pnorm( Vdiff.b.W12(W.b, h.b12.W95 + matrix(c(0,0,0,1e-5,0,0,0,0), nrow=length(vov.b12.W95),ncol=8, byrow=T),
      Xbar.Mb12[vov.b12.W95,], pop.Pb12[vov.b12.W95], nosupply.b12[vov.b12.W95,]) )
  - pnorm( Vdiff.b.W12(W.b, h.b12.W95, Xbar.Mb12[vov.b12.W95,], pop.Pb12[vov.b12.W95], nosupply.b12[vov.b12.W95,]) )
) / 1e-5 * PI[virgins.b12[vov.b12.W95],] ),
rowSums(
( pnorm( Vdiff.b.W12(W.b, h.b11.W96 + matrix(c(0,0,0,1e-5,0,0,0,0), nrow=length(vov.b11.W96),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.W96,], pop.Pb11[vov.b11.W96], nosupply.b11[vov.b11.W96,]) )
  - pnorm( Vdiff.b.W12(W.b, h.b11.W96, Xbar.Mb11[vov.b11.W96,], pop.Pb11[vov.b11.W96], nosupply.b11[vov.b11.W96,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.W96],] ),
rowSums(
( pnorm( Vdiff.b.S12(W.b, h.b12.S95 + matrix(c(0,0,0,1e-5,0,0,0,0), nrow=length(vov.b12.S95),ncol=8, byrow=T),
      Xbar.Mb12[vov.b12.S95,], nosupply.b12[vov.b12.S95,]) )
  - pnorm( Vdiff.b.S12(W.b, h.b12.S95, Xbar.Mb12[vov.b12.S95,], nosupply.b12[vov.b12.S95,]) )
) / 1e-5 * PI[virgins.b12[vov.b12.S95],] ),
rowSums(
( pnorm( Vdiff.b.S12(W.b, h.b11.S96 + matrix(c(0,0,0,1e-5,0,0,0,0), nrow=length(vov.b11.S96),ncol=8, byrow=T),
      Xbar.Mb11[vov.b11.S96,], nosupply.b11[vov.b11.S96,]) )
  - pnorm( Vdiff.b.S12(W.b, h.b11.S96, Xbar.Mb11[vov.b11.S96,], nosupply.b11[vov.b11.S96,]) )
) / 1e-5 * PI[virgins.b11[vov.b11.S96],] )
  ) ) -> temp.marg[4,1]

# B) Girls

# 9th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.g.F9(W.g, h.g9.F94 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g9.F94),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.F94,], pop.Pg9[vov.g9.F94], nosupply.g9a[vov.g9.F94,]) )
  - pnorm( Vdiff.g.F9(W.g, h.g9.F94, Xbar.Mg9[vov.g9.F94,], pop.Pg9[vov.g9.F94], nosupply.g9a[vov.g9.F94,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.F94],] ),
rowSums(
( pnorm( Vdiff.g.F9(W.g, h.g8.F95 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g8.F95),ncol=8, byrow=T),
      Xbar.Mg8[vov.g8.F95,], pop.Pg8[vov.g8.F95], nosupply.g8[vov.g8.F95,]) )
  - pnorm( Vdiff.g.F9(W.g, h.g8.F95, Xbar.Mg8[vov.g8.F95,], pop.Pg8[vov.g8.F95], nosupply.g8[vov.g8.F95,]) )
) / 1e-5 * PI[virgins.g8[vov.g8.F95],] ), 
rowSums(
( pnorm( Vdiff.g.W9(W.g, h.g9.W95 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g9.W95),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.W95,], pop.Pg9[vov.g9.W95], nosupply.g9a[vov.g9.W95,]) )
  - pnorm( Vdiff.g.W9(W.g, h.g9.W95, Xbar.Mg9[vov.g9.W95,], pop.Pg9[vov.g9.W95], nosupply.g9a[vov.g9.W95,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.W95],] ),
rowSums(
( pnorm( Vdiff.g.W9(W.g, h.g8.W96 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g8.W96),ncol=8, byrow=T),
      Xbar.Mg8[vov.g8.W96,], pop.Pg8[vov.g8.W96], nosupply.g8[vov.g8.W96,]) )
  - pnorm( Vdiff.g.W9(W.g, h.g8.W96, Xbar.Mg8[vov.g8.W96,], pop.Pg8[vov.g8.W96], nosupply.g8[vov.g8.W96,]) )
) / 1e-5 * PI[virgins.g8[vov.g8.W96],] ), 
rowSums(
( pnorm( Vdiff.g.S9(W.g, h.g9.S95 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g9.S95),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.S95,], pop.Pg9[vov.g9.S95], nosupply.g9a[vov.g9.S95,]) )
  - pnorm( Vdiff.g.S9(W.g, h.g9.S95, Xbar.Mg9[vov.g9.S95,], pop.Pg9[vov.g9.S95], nosupply.g9a[vov.g9.S95,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.S95],] ),
rowSums(
( pnorm( Vdiff.g.S9(W.g, h.g8.S96 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g8.S96),ncol=8, byrow=T),
      Xbar.Mg8[vov.g8.S96,], pop.Pg8[vov.g8.S96], nosupply.g8[vov.g8.S96,]) )
  - pnorm( Vdiff.g.S9(W.g, h.g8.S96, Xbar.Mg8[vov.g8.S96,], pop.Pg8[vov.g8.S96], nosupply.g8[vov.g8.S96,]) )
) / 1e-5 * PI[virgins.g8[vov.g8.S96],] ), 
rowSums(
( pnorm( Vdiff.g.U9(W.g, h.g9.U95 + matrix(c(0,0,0,0,1e-5,0,0,0), nrow=length(vov.g9.U95),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.U95,], pop.Pg9[vov.g9.U95], nosupply.g9a[vov.g9.U95,]) )
  - pnorm( Vdiff.g.U9(W.g, h.g9.U95, Xbar.Mg9[vov.g9.U95,], pop.Pg9[vov.g9.U95], nosupply.g9a[vov.g9.U95,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.U95],] )
  ) ) -> temp.marg[1,2]

# 10th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.g.F10(W.g, h.g10.F94 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g10.F94),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.F94,], pop.Pg10[vov.g10.F94], nosupply.g10[vov.g10.F94,]) )
  - pnorm( Vdiff.g.F10(W.g, h.g10.F94, Xbar.Mg10[vov.g10.F94,], pop.Pg10[vov.g10.F94], nosupply.g10[vov.g10.F94,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.F94],] ),
rowSums(
( pnorm( Vdiff.g.F10(W.g, h.g9.F95 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g9.F95),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.F95,], pop.Pg9[vov.g9.F95], nosupply.g9[vov.g9.F95,]) )
  - pnorm( Vdiff.g.F10(W.g, h.g9.F95, Xbar.Mg9[vov.g9.F95,], pop.Pg9[vov.g9.F95], nosupply.g9[vov.g9.F95,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.F95],] ),
rowSums(
( pnorm( Vdiff.g.W10(W.g, h.g10.W95 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g10.W95),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.W95,], pop.Pg10[vov.g10.W95], nosupply.g10[vov.g10.W95,]) )
  - pnorm( Vdiff.g.W10(W.g, h.g10.W95, Xbar.Mg10[vov.g10.W95,], pop.Pg10[vov.g10.W95], nosupply.g10[vov.g10.W95,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.W95],] ),
rowSums(
( pnorm( Vdiff.g.W10(W.g, h.g9.W96 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g9.W96),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.W96,], pop.Pg9[vov.g9.W96], nosupply.g9[vov.g9.W96,]) )
  - pnorm( Vdiff.g.W10(W.g, h.g9.W96, Xbar.Mg9[vov.g9.W96,], pop.Pg9[vov.g9.W96], nosupply.g9[vov.g9.W96,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.W96],] ),
rowSums(
( pnorm( Vdiff.g.S10(W.g, h.g10.S95 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g10.S95),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.S95,], pop.Pg10[vov.g10.S95], nosupply.g10[vov.g10.S95,]) )
  - pnorm( Vdiff.g.S10(W.g, h.g10.S95, Xbar.Mg10[vov.g10.S95,], pop.Pg10[vov.g10.S95], nosupply.g10[vov.g10.S95,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.S95],] ),
rowSums(
( pnorm( Vdiff.g.S10(W.g, h.g9.S96 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g9.S96),ncol=8, byrow=T),
      Xbar.Mg9[vov.g9.S96,], pop.Pg9[vov.g9.S96], nosupply.g9[vov.g9.S96,]) )
  - pnorm( Vdiff.g.S10(W.g, h.g9.S96, Xbar.Mg9[vov.g9.S96,], pop.Pg9[vov.g9.S96], nosupply.g9[vov.g9.S96,]) )
) / 1e-5 * PI[virgins.g9[vov.g9.S96],] ),
rowSums(
( pnorm( Vdiff.g.U10(W.g, h.g10.U95 + matrix(c(0,0,0,0,0,1e-5,0,0), nrow=length(vov.g10.U95),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.U95,], pop.Pg10[vov.g10.U95], nosupply.g10[vov.g10.U95,]) )
  - pnorm( Vdiff.g.U10(W.g, h.g10.U95, Xbar.Mg10[vov.g10.U95,], pop.Pg10[vov.g10.U95], nosupply.g10[vov.g10.U95,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.U95],] )
  ) ) -> temp.marg[2,2]

# 11th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.g.F11(W.g, h.g11.F94 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g11.F94),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.F94,], pop.Pg11[vov.g11.F94], nosupply.g11[vov.g11.F94,]) )
  - pnorm( Vdiff.g.F11(W.g, h.g11.F94, Xbar.Mg11[vov.g11.F94,], pop.Pg11[vov.g11.F94], nosupply.g11[vov.g11.F94,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.F94],] ),
rowSums(
( pnorm( Vdiff.g.F11(W.g, h.g10.F95 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g10.F95),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.F95,], pop.Pg10[vov.g10.F95], nosupply.g10[vov.g10.F95,]) )
  - pnorm( Vdiff.g.F11(W.g, h.g10.F95, Xbar.Mg10[vov.g10.F95,], pop.Pg10[vov.g10.F95], nosupply.g10[vov.g10.F95,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.F95],] ),
rowSums(
( pnorm( Vdiff.g.W11(W.g, h.g11.W95 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g11.W95),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.W95,], pop.Pg11[vov.g11.W95], nosupply.g11[vov.g11.W95,]) )
  - pnorm( Vdiff.g.W11(W.g, h.g11.W95, Xbar.Mg11[vov.g11.W95,], pop.Pg11[vov.g11.W95], nosupply.g11[vov.g11.W95,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.W95],] ),
rowSums(
( pnorm( Vdiff.g.W11(W.g, h.g10.W96 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g10.W96),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.W96,], pop.Pg10[vov.g10.W96], nosupply.g10[vov.g10.W96,]) )
  - pnorm( Vdiff.g.W11(W.g, h.g10.W96, Xbar.Mg10[vov.g10.W96,], pop.Pg10[vov.g10.W96], nosupply.g10[vov.g10.W96,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.W96],] ),
rowSums(
( pnorm( Vdiff.g.S11(W.g, h.g11.S95 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g11.S95),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.S95,], pop.Pg11[vov.g11.S95], nosupply.g11[vov.g11.S95,]) )
  - pnorm( Vdiff.g.S11(W.g, h.g11.S95, Xbar.Mg11[vov.g11.S95,], pop.Pg11[vov.g11.S95], nosupply.g11[vov.g11.S95,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.S95],] ),
rowSums(
( pnorm( Vdiff.g.S11(W.g, h.g10.S96 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g10.S96),ncol=8, byrow=T),
      Xbar.Mg10[vov.g10.S96,], pop.Pg10[vov.g10.S96], nosupply.g10[vov.g10.S96,]) )
  - pnorm( Vdiff.g.S11(W.g, h.g10.S96, Xbar.Mg10[vov.g10.S96,], pop.Pg10[vov.g10.S96], nosupply.g10[vov.g10.S96,]) )
) / 1e-5 * PI[virgins.g10[vov.g10.S96],] ),
rowSums(
( pnorm( Vdiff.g.U11(W.g, h.g11.U95 + matrix(c(0,0,0,0,0,0,1e-5,0), nrow=length(vov.g11.U95),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.U95,], pop.Pg11[vov.g11.U95], nosupply.g11[vov.g11.U95,]) )
  - pnorm( Vdiff.g.U11(W.g, h.g11.U95, Xbar.Mg11[vov.g11.U95,], pop.Pg11[vov.g11.U95], nosupply.g11[vov.g11.U95,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.U95],] )
  ) ) -> temp.marg[3,2]

# 12th grade (to matrix):

mean(c(
rowSums(
( pnorm( Vdiff.g.F12(W.g, h.g12.F94 + matrix(c(0,0,0,0,0,0,0,1e-5), nrow=length(vov.g12.F94),ncol=8, byrow=T),
      Xbar.Mg12[vov.g12.F94,], pop.Pg12[vov.g12.F94], nosupply.g12[vov.g12.F94,]) )
  - pnorm( Vdiff.g.F12(W.g, h.g12.F94, Xbar.Mg12[vov.g12.F94,], pop.Pg12[vov.g12.F94], nosupply.g12[vov.g12.F94,]) )
) / 1e-5 * PI[virgins.g12[vov.g12.F94],] ),
rowSums(
( pnorm( Vdiff.g.F12(W.g, h.g11.F95 + matrix(c(0,0,0,0,0,0,0,1e-5), nrow=length(vov.g11.F95),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.F95,], pop.Pg11[vov.g11.F95], nosupply.g11[vov.g11.F95,]) )
  - pnorm( Vdiff.g.F12(W.g, h.g11.F95, Xbar.Mg11[vov.g11.F95,], pop.Pg11[vov.g11.F95], nosupply.g11[vov.g11.F95,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.F95],] ),
rowSums(
( pnorm( Vdiff.g.W12(W.g, h.g12.W95 + matrix(c(0,0,0,0,0,0,0,1e-5), nrow=length(vov.g12.W95),ncol=8, byrow=T),
      Xbar.Mg12[vov.g12.W95,], pop.Pg12[vov.g12.W95], nosupply.g12[vov.g12.W95,]) )
  - pnorm( Vdiff.g.W12(W.g, h.g12.W95, Xbar.Mg12[vov.g12.W95,], pop.Pg12[vov.g12.W95], nosupply.g12[vov.g12.W95,]) )
) / 1e-5 * PI[virgins.g12[vov.g12.W95],] ),
rowSums(
( pnorm( Vdiff.g.W12(W.g, h.g11.W96 + matrix(c(0,0,0,0,0,0,0,1e-5), nrow=length(vov.g11.W96),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.W96,], pop.Pg11[vov.g11.W96], nosupply.g11[vov.g11.W96,]) )
  - pnorm( Vdiff.g.W12(W.g, h.g11.W96, Xbar.Mg11[vov.g11.W96,], pop.Pg11[vov.g11.W96], nosupply.g11[vov.g11.W96,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.W96],] ),
rowSums(
( pnorm( Vdiff.g.S12(W.g, h.g12.S95 + matrix(c(0,0,0,0,0,0,0,1e-5), nrow=length(vov.g12.S95),ncol=8, byrow=T),
      Xbar.Mg12[vov.g12.S95,], nosupply.g12[vov.g12.S95,]) )
  - pnorm( Vdiff.g.S12(W.g, h.g12.S95, Xbar.Mg12[vov.g12.S95,], nosupply.g12[vov.g12.S95,]) )
) / 1e-5 * PI[virgins.g12[vov.g12.S95],] ),
rowSums(
( pnorm( Vdiff.g.S12(W.g, h.g11.S96 + matrix(c(0,0,0,0,0,0,0,1e-5), nrow=length(vov.g11.S96),ncol=8, byrow=T),
      Xbar.Mg11[vov.g11.S96,], nosupply.g11[vov.g11.S96,]) )
  - pnorm( Vdiff.g.S12(W.g, h.g11.S96, Xbar.Mg11[vov.g11.S96,], nosupply.g11[vov.g11.S96,]) )
) / 1e-5 * PI[virgins.g11[vov.g11.S96],] )
  ) ) -> temp.marg[4,2]

# C) Results

temp.marg



### SUPPLY EFFECT

# A) Boys

rbind(
mean( c(
  Elam.F94[virgins.b9[vov.b9.F94]], Elam.F95[virgins.b8[vov.b8.F95]],
  Elam.W95[virgins.b9[vov.b9.W95]], Elam.W96[virgins.b8[vov.b8.W96]],
  Elam.S95[virgins.b9[vov.b9.S95]], Elam.S96[virgins.b8[vov.b8.S96]],
  Elam.U95[virgins.b9[vov.b9.U95]]
  ) * (1 - c(
  Elam.F94[virgins.b9[vov.b9.F94]], Elam.F95[virgins.b8[vov.b8.F95]],
  Elam.W95[virgins.b9[vov.b9.W95]], Elam.W96[virgins.b8[vov.b8.W96]],
  Elam.S95[virgins.b9[vov.b9.S95]], Elam.S96[virgins.b8[vov.b8.S96]],
  Elam.U95[virgins.b9[vov.b9.U95]]
  ) ) ) * c(lambda.b9[2], NA, lambda.b9[3]),
mean( c(
  Elam.F94[virgins.b10[vov.b10.F94]], Elam.F95[virgins.b9[vov.b9.F95]],
  Elam.W95[virgins.b10[vov.b10.W95]], Elam.W96[virgins.b9[vov.b9.W96]],
  Elam.S95[virgins.b10[vov.b10.S95]], Elam.S96[virgins.b9[vov.b9.S96]],
  Elam.U95[virgins.b10[vov.b10.U95]]
  ) * (1 - c(
  Elam.F94[virgins.b10[vov.b10.F94]], Elam.F95[virgins.b9[vov.b9.F95]],
  Elam.W95[virgins.b10[vov.b10.W95]], Elam.W96[virgins.b9[vov.b9.W96]],
  Elam.S95[virgins.b10[vov.b10.S95]], Elam.S96[virgins.b9[vov.b9.S96]],
  Elam.U95[virgins.b10[vov.b10.U95]]
  ) ) ) * lambda.b10[2:4],
mean( c(
  Elam.F94[virgins.b11[vov.b11.F94]], Elam.F95[virgins.b10[vov.b10.F95]],
  Elam.W95[virgins.b11[vov.b11.W95]], Elam.W96[virgins.b10[vov.b10.W96]],
  Elam.S95[virgins.b11[vov.b11.S95]], Elam.S96[virgins.b10[vov.b10.S96]],
  Elam.U95[virgins.b11[vov.b11.U95]]
  ) * (1 - c(
  Elam.F94[virgins.b11[vov.b11.F94]], Elam.F95[virgins.b10[vov.b10.F95]],
  Elam.W95[virgins.b11[vov.b11.W95]], Elam.W96[virgins.b10[vov.b10.W96]],
  Elam.S95[virgins.b11[vov.b11.S95]], Elam.S96[virgins.b10[vov.b10.S96]],
  Elam.U95[virgins.b11[vov.b11.U95]]
  ) ) ) * lambda.b11[2:4],
mean( c(
  Elam.F94[virgins.b12[vov.b12.F94]], Elam.F95[virgins.b11[vov.b11.F95]],
  Elam.W95[virgins.b12[vov.b12.W95]], Elam.W96[virgins.b11[vov.b11.W96]],
  Elam.S95[virgins.b12[vov.b12.S95]], Elam.S96[virgins.b11[vov.b11.S96]]
  ) * (1 - c(
  Elam.F94[virgins.b12[vov.b12.F94]], Elam.F95[virgins.b11[vov.b11.F95]],
  Elam.W95[virgins.b12[vov.b12.W95]], Elam.W96[virgins.b11[vov.b11.W96]],
  Elam.S95[virgins.b12[vov.b12.S95]], Elam.S96[virgins.b11[vov.b11.S96]]
  ) ) ) * c(lambda.b12[2:3], NA)
)

# B) Girls

rbind(
mean( c(
  Elam.F94[virgins.g9[vov.g9.F94]], Elam.F95[virgins.g8[vov.g8.F95]],
  Elam.W95[virgins.g9[vov.g9.W95]], Elam.W96[virgins.g8[vov.g8.W96]],
  Elam.S95[virgins.g9[vov.g9.S95]], Elam.S96[virgins.g8[vov.g8.S96]],
  Elam.U95[virgins.g9[vov.g9.U95]]
  ) * (1 - c(
  Elam.F94[virgins.g9[vov.g9.F94]], Elam.F95[virgins.g8[vov.g8.F95]],
  Elam.W95[virgins.g9[vov.g9.W95]], Elam.W96[virgins.g8[vov.g8.W96]],
  Elam.S95[virgins.g9[vov.g9.S95]], Elam.S96[virgins.g8[vov.g8.S96]],
  Elam.U95[virgins.g9[vov.g9.U95]]
  ) ) ) * lambda.g9[2:4],
mean( c(
  Elam.F94[virgins.g10[vov.g10.F94]], Elam.F95[virgins.g9[vov.g9.F95]],
  Elam.W95[virgins.g10[vov.g10.W95]], Elam.W96[virgins.g9[vov.g9.W96]],
  Elam.S95[virgins.g10[vov.g10.S95]], Elam.S96[virgins.g9[vov.g9.S96]],
  Elam.U95[virgins.g10[vov.g10.U95]]
  ) * (1 - c(
  Elam.F94[virgins.g10[vov.g10.F94]], Elam.F95[virgins.g9[vov.g9.F95]],
  Elam.W95[virgins.g10[vov.g10.W95]], Elam.W96[virgins.g9[vov.g9.W96]],
  Elam.S95[virgins.g10[vov.g10.S95]], Elam.S96[virgins.g9[vov.g9.S96]],
  Elam.U95[virgins.g10[vov.g10.U95]]
  ) ) ) * lambda.g10[2:4],
mean( c(
  Elam.F94[virgins.g11[vov.g11.F94]], Elam.F95[virgins.g10[vov.g10.F95]],
  Elam.W95[virgins.g11[vov.g11.W95]], Elam.W96[virgins.g10[vov.g10.W96]],
  Elam.S95[virgins.g11[vov.g11.S95]], Elam.S96[virgins.g10[vov.g10.S96]],
  Elam.U95[virgins.g11[vov.g11.U95]]
  ) * (1 - c(
  Elam.F94[virgins.g11[vov.g11.F94]], Elam.F95[virgins.g10[vov.g10.F95]],
  Elam.W95[virgins.g11[vov.g11.W95]], Elam.W96[virgins.g10[vov.g10.W96]],
  Elam.S95[virgins.g11[vov.g11.S95]], Elam.S96[virgins.g10[vov.g10.S96]],
  Elam.U95[virgins.g11[vov.g11.U95]]
  ) ) ) * lambda.g11[2:4],
mean( c(
  Elam.F94[virgins.g12[vov.g12.F94]], Elam.F95[virgins.g11[vov.g11.F95]],
  Elam.W95[virgins.g12[vov.g12.W95]], Elam.W96[virgins.g11[vov.g11.W96]],
  Elam.S95[virgins.g12[vov.g12.S95]], Elam.S96[virgins.g11[vov.g11.S96]]
  ) * (1 - c(
  Elam.F94[virgins.g12[vov.g12.F94]], Elam.F95[virgins.g11[vov.g11.F95]],
  Elam.W95[virgins.g12[vov.g12.W95]], Elam.W96[virgins.g11[vov.g11.W96]],
  Elam.S95[virgins.g12[vov.g12.S95]], Elam.S96[virgins.g11[vov.g11.S96]]
  ) ) ) * lambda.g12[2:4]
)



### TYPE DISTRIBUTION

temp.marg <- matrix(nrow=length(indvars),ncol=2)

for (k in 1:length(indvars) )  {
  #
  temp.0 <- temp.1 <- as.matrix(data[,indvars])
  temp.0[,k] <- 0; temp.1[,k] <- 1
  #
  colMeans(
    pifun(pi2.b,pi3.b)( cbind(1,hbar.0,temp.1)[c(virgins.b8,virgins.b9),] )
    - pifun(pi2.b,pi3.b)( cbind(1,hbar.0,temp.0)[c(virgins.b8,virgins.b9),] )
    )[3] -> temp.marg[k,1]
  #
  colMeans(
    pifun(pi2.g,pi3.g)( cbind(1,hbar.0,temp.1)[c(virgins.g8,virgins.g9),] )
    - pifun(pi2.g,pi3.g)( cbind(1,hbar.0,temp.0)[c(virgins.g8,virgins.g9),] )
    )[3] -> temp.marg[k,2]
  #
  }

temp.marg

rm(temp.0,temp.1)
