/* Extract covariates from raw data files (Add Health, Wave I). */
/* Raw files are allwave1.dta, Homewt1.dta, Schadm1.xpt, Inschool.xpt */



// INDIVIDUAL LEVEL DATA

* Individual Variables (Wave I):

use aid scid commid imonth iyear bio_sex ///
h1gi4-h1gi9 ///
h1gi18-h1gi21 ///
h1gh28 h1gh29 ///
h1hr14 h1hr15 ///
h1hs1 h1hs2a h1hs2b h1hs2c h1hs2d h1hs2e h1hs7 h1hs8a h1hs8b h1hs8c h1hs8d h1hs8e ///
h1mp* h1fp1-h1fp7 ///
h1ee1 h1ee2 ///
pa3 pa10 pa12 pa55 pb8 ///
using allwave1

* NOTE: "scid" may identify the middle school, not high school.

* use aid scid commid imonth iyear bio_sex h1gi4-h1gi9 h1gi18-h1gi21 h1gh28 h1gh29 h1hr14 h1hr15 h1hs1 h1hs2a h1hs2b h1hs2c h1hs2d h1hs2e h1hs7 h1hs8a h1hs8b h1hs8c h1hs8d h1hs8e h1mp* h1fp1-h1fp7 h1ee1 h1ee2 pa3 pa10 pa12 pa55 pb8 using allwave1
* (above command is for interactive use)

* Survey Weights (Wave I):

sort aid
merge aid using Homewt1.dta, keep(gswgt1)
tab _m
drop _m

* Save:

compress
sort aid
save created/covariates, replace

* Grade cohort from In-School survey:

fdause Inschool.xpt
keep aid s1 s2 s3

compress
sort aid
save created/inschool, replace



// SCHOOL LEVEL DATA

* School Info (Wave I):

fdause Schadm1.xpt
keep a1a-a1o a3 a24-a27 a28e a28g a28h a28i a28q a29* a30 aschlcde asize atype aurban aregion
compress

rename aschlcde scid

sort scid
save created/schoolinfo, replace
