/* Identify individuals with homosexual sexual activity. */



// WAVE 1 DATA

* Import data:

use aid bio_sex h1gi20 h1co1 h1nr1 h1nr2 h1r*20* h1nr15* h1r*21o* h1r*21p* using allwave1

* Romantic attraction to same sex:

gen byte homoattr = bio==2 & h1nr1==1
replace homoattr = 1 if bio==1 & h1nr2==1

* Romantic involvement with same sex:

gen byte homorom = 0

foreach var of varlist h1nr15* h1r*20*  {
  replace homorom = 1 if bio_sex==1 & `var' == 1
  replace homorom = 1 if bio_sex==2 & `var' == 2
  }

* Sexual activity with same sex:

gen byte homosex = 0

forvalues par=1/3  {
  replace homosex = 1 if bio_sex==1 & h1nr15_`par' == 1
  replace homosex = 1 if bio_sex==2 & h1nr15_`par' == 2
  replace homosex = 1 if bio_sex==1 & h1rx20_`par' == 1
  replace homosex = 1 if bio_sex==2 & h1rx20_`par' == 2
  replace homosex = 1 if bio_sex==1 & h1ri20_`par' == 1 & h1ri21o`par'==1
  replace homosex = 1 if bio_sex==2 & h1ri20_`par' == 2 & h1ri21o`par'==1 
  }

* Save:

sort aid
save created/temp, replace



// WAVE 2 DATA

* Import data:

use aid h2co2 h2nr1 h2nr2 h2r*32* h2nr24* h2r*33m* h2r*33n* using wave2
destring h2r*33*, replace force

* Merge with Wave 1 data:

sort aid
merge aid using created/temp
tab _m
rename _m mergeW2

* Romantic attraction to same sex:

replace homoattr = 1 if bio==2 & h2nr1==1
replace homoattr = 1 if bio==1 & h2nr2==1

* Romantic involvement with same sex:

foreach var of varlist h2nr24* h2r*32*  {
  replace homorom = 1 if bio_sex==1 & `var' == 1
  replace homorom = 1 if bio_sex==2 & `var' == 2
  }

* Sexual activity with same sex:

forvalues par=1/3  {
  replace homosex = 1 if bio_sex==1 & h2nr24_`par' == 1
  replace homosex = 1 if bio_sex==2 & h2nr24_`par' == 2
  replace homosex = 1 if bio_sex==1 & h2rx32_`par' == 1
  replace homosex = 1 if bio_sex==2 & h2rx32_`par' == 2
  replace homosex = 1 if bio_sex==1 & h2ri32_`par' == 1 & h2ri33m`par'==1
  replace homosex = 1 if bio_sex==2 & h2ri32_`par' == 2 & h2ri33m`par'==1 
  }

* Save:

sort aid
save created/temp_samesex, replace
* (this temp file will be used in 'analytic_file.do')



// TABULATE RAW DATA

table h1gi20 homoattr bio
table h1gi20 homorom bio
table h1gi20 homosex bio
table h1gi20 bio, c(mean homoattr)
table h1gi20 bio, c(mean homorom)
table h1gi20 bio, c(mean homosex)

table h1gi20 homoattr bio if mergeW2==3
table h1gi20 homorom bio if mergeW2==3
table h1gi20 homosex bio if mergeW2==3
table h1gi20 bio if mergeW2==3, c(mean homoattr)
table h1gi20 bio if mergeW2==3, c(mean homorom)
table h1gi20 bio if mergeW2==3, c(mean homosex)


