# Alter the estimated model to define the counterfactuals.



### 1) ELIMINATE PREFERENCE INTERACTION

# Replace model (solution programs):

source("~/data/replication/code/solve_model/nopeer/a_load_model.R")

# Remove preference interaction:

g.b <- 0; g.g <- 0

# Use likelihood fn to update auxiliary parameters:
# (iterate until value does not change)

for (i in 1:5)  {
print( like.final(
c(a1.b,g.b, W.b,v.b, a1.g,g.g, W.g,v.g,
  lambda.b9[1],lambda.b10[1],lambda.b11[1],lambda.b12[1],lambda.b10[2:4], 
  lambda.g9[1],lambda.g10[1],lambda.g11[1],lambda.g12[1],lambda.g10[2:4],
  pi2.b,pi3.b, pi2.g,pi3.g)
  ) , 8)
}

# Save simulation file:

save.image("sim.RData")
quit(save="no")



### 2) ELIMINATE MARGINAL EFFECT OF LOCAL SUPPLY

# Replace matching function parameters:

lambda.b10[2:4] <- 0; lambda.g10[2:4] <- 0

# Use likelihood fn to update auxiliary parameters:
# (iterate until value does not change)

for (i in 1:5)  {
print( like.final(
c(a1.b,g.b, W.b,v.b, a1.g,g.g, W.g,v.g,
  lambda.b9[1],lambda.b10[1],lambda.b11[1],lambda.b12[1],lambda.b10[2:4], 
  lambda.g9[1],lambda.g10[1],lambda.g11[1],lambda.g12[1],lambda.g10[2:4],
  pi2.b,pi3.b, pi2.g,pi3.g)
  ) , 8)
}

# Save simulation file:

save.image("sim.RData")
quit(save="no")



### 3) ISOLATE NINTH GRADE

# Replace model (solution programs):

source("~/data/replication/code/solve_model/nopeer/a_load_model.R")

# Replace likelihood function:

source("~/data/replication/code/simulation/likeli_ninthgrd.R")

# Replace simulator function:

source("~/data/replication/code/simulation/sim_ninthgrd.R")

# Set all schools to have ninth grade isolated:

grd9sep <- rep(TRUE, nrow(data) )

# Use likelihood fn to update auxiliary parameters:
# (iterate until value does not change)

for (i in 1:5)  {
print( like.final(
c(a1.b,g.b, W.b,v.b, a1.g,g.g, W.g,v.g,
  lambda.b9[1],lambda.b10[1],lambda.b11[1],lambda.b12[1],lambda.b10[2:4], 
  lambda.g9[1],lambda.g10[1],lambda.g11[1],lambda.g12[1],lambda.g10[2:4],
  pi2.b,pi3.b, pi2.g,pi3.g)
  ) , 8)
}

# Save simulation file:

save.image("sim.RData")
quit(save="no")
