# Replace the simulator function for the counterfactual where 
# the ninth grade is isolated from the other grades in high school.



### SIMULATOR

supersim <- function(parameters)  {

###

### A) PARAMETERS AND STORAGE

# Parameters:

parassign(parameters)

# Vectors for simulated outcomes:

as.logical(nonvirg_0) -> nonvirg.1sim -> nonvirg.2sim -> nonvirg.3sim -> 
  nonvirg.4sim -> nonvirg.5sim -> nonvirg.6sim -> nonvirg.7sim -> 
  nonvirg.8sim -> nonvirg.9sim -> nonvirg.10sim -> nonvirg.11sim ->
  nonvirg.12sim -> nonvirg.13sim -> nonvirg.14sim -> nonvirg.15sim

nonvirg.4sim[b8] <- as.logical(nonvirg_4[b8]); nonvirg.4sim[g8] <- as.logical(nonvirg_4[g8])
nonvirg.8sim[b7] <- as.logical(nonvirg_7[b7]); nonvirg.8sim[g7] <- as.logical(nonvirg_7[g7])
# NOTE: This misses one quarter, and the 7th grade cohort is low to begin with.

# Search matrices:

ED.F94 <- ED.W95 <- ED.S95 <- ED.U95 <- ED.F95 <- ED.W96 <- ED.S96 <- matrix(1, n, 3)
ED.S96 -> ED.U96 -> ED.F96 -> ED.W97 -> ED.S97 -> ED.U97 -> ED.F97 -> ED.W98 -> ED.S98

###

### B) TYPES

PI <<- PI.0 <- matrix(1/3, n, 3)

PI.0[c(virgins.b7,virgins.b8,virgins.bHS),] <- 
  pifun(pi2.b,pi3.b)( cbind(1,hbar.0,as.matrix(data[,indvars]))[c(virgins.b7,virgins.b8,virgins.bHS),] )

PI.0[c(virgins.g7,virgins.g8,virgins.gHS),] <-
  pifun(pi2.g,pi3.g)( cbind(1,hbar.0,as.matrix(data[,indvars]))[c(virgins.g7,virgins.g8,virgins.gHS),] )

# 7th - 9th grade cohorts:

PI[c(virgins.b7,virgins.b8,virgins.b9,virgins.g7,virgins.g8,virgins.g9),] <<-
  PI.0[c(virgins.b7,virgins.b8,virgins.b9,virgins.g7,virgins.g8,virgins.g9),]

# 10th grade cohort:

h1.b <- h.b10.F94; h2.b <- psi.qtr(h1.b); h3.b <- psi.qtr(h2.b); h4.b <- psi.qtr(h3.b)
h1.g <- h.g10.F94; h2.g <- psi.qtr(h1.g); h3.g <- psi.qtr(h2.g); h4.g <- psi.qtr(h3.g)

Laux1.b <- cbind(1,h1.b,Xbar.Mb10) %*% Laux.b.F9; Laux1.b <- ifelse(Laux1.b < 0, 0, Laux1.b)
Laux2.b <- cbind(1,h2.b,Xbar.Mb10) %*% Laux.b.W9; Laux2.b <- ifelse(Laux2.b < 0, 0, Laux2.b)
Laux3.b <- cbind(1,h3.b,Xbar.Mb10) %*% Laux.b.S9; Laux3.b <- ifelse(Laux3.b < 0, 0, Laux3.b)
Laux4.b <- cbind(1,h4.b,Xbar.Mb10) %*% Laux.b.U9; Laux4.b <- ifelse(Laux4.b < 0, 0, Laux4.b)

Laux1.g <- cbind(1,h1.g,Xbar.Mg10) %*% Laux.g.F9; Laux1.g <- ifelse(Laux1.g < 0, 0, Laux1.g)
Laux2.g <- cbind(1,h2.g,Xbar.Mg10) %*% Laux.g.W9; Laux2.g <- ifelse(Laux2.g < 0, 0, Laux2.g)
Laux3.g <- cbind(1,h3.g,Xbar.Mg10) %*% Laux.g.S9; Laux3.g <- ifelse(Laux3.g < 0, 0, Laux3.g)
Laux4.g <- cbind(1,h4.g,Xbar.Mg10) %*% Laux.g.U9; Laux4.g <- ifelse(Laux4.g < 0, 0, Laux4.g)

Pvirg.b <- PI.0[virgins.b10,] * (1-Laux1.b)*(1-Laux2.b)*(1-Laux3.b)*(1-Laux4.b)
Pvirg.g <- PI.0[virgins.g10,] * (1-Laux1.g)*(1-Laux2.g)*(1-Laux3.g)*(1-Laux4.g)

PI[virgins.b10,] <<- Pvirg.b / rowSums(Pvirg.b)
PI[virgins.g10,] <<- Pvirg.g / rowSums(Pvirg.g)

# 11th grade cohort:

h1.b <- h.b11.F94; h2.b <- psi.qtr(h1.b); h3.b <- psi.qtr(h2.b); h4.b <- psi.qtr(h3.b)
  h5.b <- psi.ann(h1.b); h6.b <- psi.qtr(h5.b); h7.b <- psi.qtr(h6.b); h8.b <- psi.qtr(h7.b)
h1.g <- h.g11.F94; h2.g <- psi.qtr(h1.g); h3.g <- psi.qtr(h2.g); h4.g <- psi.qtr(h3.g)
  h5.g <- psi.ann(h1.g); h6.g <- psi.qtr(h5.g); h7.g <- psi.qtr(h6.g); h8.g <- psi.qtr(h7.g)

Laux1.b <- cbind(1,h1.b,Xbar.Mb11) %*% Laux.b.F9; Laux1.b <- ifelse(Laux1.b < 0, 0, Laux1.b)
Laux2.b <- cbind(1,h2.b,Xbar.Mb11) %*% Laux.b.W9; Laux2.b <- ifelse(Laux2.b < 0, 0, Laux2.b)
Laux3.b <- cbind(1,h3.b,Xbar.Mb11) %*% Laux.b.S9; Laux3.b <- ifelse(Laux3.b < 0, 0, Laux3.b)
Laux4.b <- cbind(1,h4.b,Xbar.Mb11) %*% Laux.b.U9; Laux4.b <- ifelse(Laux4.b < 0, 0, Laux4.b)
Laux5.b <- cbind(1,h5.b,Xbar.Mb11) %*% Laux.b.F10; Laux5.b <- ifelse(Laux5.b < 0, 0, Laux5.b)
Laux6.b <- cbind(1,h6.b,Xbar.Mb11) %*% Laux.b.W10; Laux6.b <- ifelse(Laux6.b < 0, 0, Laux6.b)
Laux7.b <- cbind(1,h7.b,Xbar.Mb11) %*% Laux.b.S10; Laux7.b <- ifelse(Laux7.b < 0, 0, Laux7.b)
Laux8.b <- cbind(1,h8.b,Xbar.Mb11) %*% Laux.b.U10; Laux8.b <- ifelse(Laux8.b < 0, 0, Laux8.b)

Laux1.g <- cbind(1,h1.g,Xbar.Mg11) %*% Laux.g.F9; Laux1.g <- ifelse(Laux1.g < 0, 0, Laux1.g)
Laux2.g <- cbind(1,h2.g,Xbar.Mg11) %*% Laux.g.W9; Laux2.g <- ifelse(Laux2.g < 0, 0, Laux2.g)
Laux3.g <- cbind(1,h3.g,Xbar.Mg11) %*% Laux.g.S9; Laux3.g <- ifelse(Laux3.g < 0, 0, Laux3.g)
Laux4.g <- cbind(1,h4.g,Xbar.Mg11) %*% Laux.g.U9; Laux4.g <- ifelse(Laux4.g < 0, 0, Laux4.g)
Laux5.g <- cbind(1,h5.g,Xbar.Mg11) %*% Laux.g.F10; Laux5.g <- ifelse(Laux5.g < 0, 0, Laux5.g)
Laux6.g <- cbind(1,h6.g,Xbar.Mg11) %*% Laux.g.W10; Laux6.g <- ifelse(Laux6.g < 0, 0, Laux6.g)
Laux7.g <- cbind(1,h7.g,Xbar.Mg11) %*% Laux.g.S10; Laux7.g <- ifelse(Laux7.g < 0, 0, Laux7.g)
Laux8.g <- cbind(1,h8.g,Xbar.Mg11) %*% Laux.g.U10; Laux8.g <- ifelse(Laux8.g < 0, 0, Laux8.g)

Pvirg.b <- PI.0[virgins.b11,] * (1-Laux1.b)*(1-Laux2.b)*(1-Laux3.b)*(1-Laux4.b)*
  (1-Laux5.b)*(1-Laux6.b)*(1-Laux7.b)*(1-Laux8.b)
Pvirg.g <- PI.0[virgins.g11,] * (1-Laux1.g)*(1-Laux2.g)*(1-Laux3.g)*(1-Laux4.g)*
  (1-Laux5.g)*(1-Laux6.g)*(1-Laux7.g)*(1-Laux8.g)

PI[virgins.b11,] <<- Pvirg.b / rowSums(Pvirg.b)
PI[virgins.g11,] <<- Pvirg.g / rowSums(Pvirg.g)

# 12th grade cohort:

h1.b <- h.b12.F94; h2.b <- psi.qtr(h1.b); h3.b <- psi.qtr(h2.b); h4.b <- psi.qtr(h3.b)
  h5.b <- psi.ann(h1.b); h6.b <- psi.qtr(h5.b); h7.b <- psi.qtr(h6.b); h8.b <- psi.qtr(h7.b)
  h9.b <- psi.ann(h5.b); h10.b <- psi.qtr(h9.b); h11.b <- psi.qtr(h10.b); h12.b <- psi.qtr(h11.b)
h1.g <- h.g12.F94; h2.g <- psi.qtr(h1.g); h3.g <- psi.qtr(h2.g); h4.g <- psi.qtr(h3.g)
  h5.g <- psi.ann(h1.g); h6.g <- psi.qtr(h5.g); h7.g <- psi.qtr(h6.g); h8.g <- psi.qtr(h7.g)
  h9.g <- psi.ann(h5.g); h10.g <- psi.qtr(h9.g); h11.g <- psi.qtr(h10.g); h12.g <- psi.qtr(h11.g)

Laux1.b <- cbind(1,h1.b,Xbar.Mb12) %*% Laux.b.F9; Laux1.b <- ifelse(Laux1.b < 0, 0, Laux1.b)
Laux2.b <- cbind(1,h2.b,Xbar.Mb12) %*% Laux.b.W9; Laux2.b <- ifelse(Laux2.b < 0, 0, Laux2.b)
Laux3.b <- cbind(1,h3.b,Xbar.Mb12) %*% Laux.b.S9; Laux3.b <- ifelse(Laux3.b < 0, 0, Laux3.b)
Laux4.b <- cbind(1,h4.b,Xbar.Mb12) %*% Laux.b.U9; Laux4.b <- ifelse(Laux4.b < 0, 0, Laux4.b)
Laux5.b <- cbind(1,h5.b,Xbar.Mb12) %*% Laux.b.F10; Laux5.b <- ifelse(Laux5.b < 0, 0, Laux5.b)
Laux6.b <- cbind(1,h6.b,Xbar.Mb12) %*% Laux.b.W10; Laux6.b <- ifelse(Laux6.b < 0, 0, Laux6.b)
Laux7.b <- cbind(1,h7.b,Xbar.Mb12) %*% Laux.b.S10; Laux7.b <- ifelse(Laux7.b < 0, 0, Laux7.b)
Laux8.b <- cbind(1,h8.b,Xbar.Mb12) %*% Laux.b.U10; Laux8.b <- ifelse(Laux8.b < 0, 0, Laux8.b)
Laux9.b <- cbind(1,h9.b,Xbar.Mb12) %*% Laux.b.F11; Laux9.b <- ifelse(Laux9.b < 0, 0, Laux9.b)
Laux10.b <- cbind(1,h10.b,Xbar.Mb12) %*% Laux.b.W11; Laux10.b <- ifelse(Laux10.b < 0, 0, Laux10.b)
Laux11.b <- cbind(1,h11.b,Xbar.Mb12) %*% Laux.b.S11; Laux11.b <- ifelse(Laux11.b < 0, 0, Laux11.b)
Laux12.b <- cbind(1,h12.b,Xbar.Mb12) %*% Laux.b.U11; Laux12.b <- ifelse(Laux12.b < 0, 0, Laux12.b)

Laux1.g <- cbind(1,h1.g,Xbar.Mg12) %*% Laux.g.F9; Laux1.g <- ifelse(Laux1.g < 0, 0, Laux1.g)
Laux2.g <- cbind(1,h2.g,Xbar.Mg12) %*% Laux.g.W9; Laux2.g <- ifelse(Laux2.g < 0, 0, Laux2.g)
Laux3.g <- cbind(1,h3.g,Xbar.Mg12) %*% Laux.g.S9; Laux3.g <- ifelse(Laux3.g < 0, 0, Laux3.g)
Laux4.g <- cbind(1,h4.g,Xbar.Mg12) %*% Laux.g.U9; Laux4.g <- ifelse(Laux4.g < 0, 0, Laux4.g)
Laux5.g <- cbind(1,h5.g,Xbar.Mg12) %*% Laux.g.F10; Laux5.g <- ifelse(Laux5.g < 0, 0, Laux5.g)
Laux6.g <- cbind(1,h6.g,Xbar.Mg12) %*% Laux.g.W10; Laux6.g <- ifelse(Laux6.g < 0, 0, Laux6.g)
Laux7.g <- cbind(1,h7.g,Xbar.Mg12) %*% Laux.g.S10; Laux7.g <- ifelse(Laux7.g < 0, 0, Laux7.g)
Laux8.g <- cbind(1,h8.g,Xbar.Mg12) %*% Laux.g.U10; Laux8.g <- ifelse(Laux8.g < 0, 0, Laux8.g)
Laux9.g <- cbind(1,h9.g,Xbar.Mg12) %*% Laux.g.F11; Laux9.g <- ifelse(Laux9.g < 0, 0, Laux9.g)
Laux10.g <- cbind(1,h10.g,Xbar.Mg12) %*% Laux.g.W11; Laux10.g <- ifelse(Laux10.g < 0, 0, Laux10.g)
Laux11.g <- cbind(1,h11.g,Xbar.Mg12) %*% Laux.g.S11; Laux11.g <- ifelse(Laux11.g < 0, 0, Laux11.g)
Laux12.g <- cbind(1,h12.g,Xbar.Mg12) %*% Laux.g.U11; Laux12.g <- ifelse(Laux12.g < 0, 0, Laux12.g)

Pvirg.b <- PI.0[virgins.b12,] * (1-Laux1.b)*(1-Laux2.b)*(1-Laux3.b)*(1-Laux4.b)*
  (1-Laux5.b)*(1-Laux6.b)*(1-Laux7.b)*(1-Laux8.b)*(1-Laux9.b)*(1-Laux10.b)*(1-Laux11.b)*(1-Laux12.b)
Pvirg.g <- PI.0[virgins.g12,] * (1-Laux1.g)*(1-Laux2.g)*(1-Laux3.g)*(1-Laux4.g)*
  (1-Laux5.g)*(1-Laux6.g)*(1-Laux7.g)*(1-Laux8.g)*(1-Laux9.g)*(1-Laux10.g)*(1-Laux11.g)*(1-Laux12.g)

PI[virgins.b12,] <<- Pvirg.b / rowSums(Pvirg.b)
PI[virgins.g12,] <<- Pvirg.g / rowSums(Pvirg.g)

# Simulate w_i:

CDF.w2 <<- PI[,1]+PI[,2]

k.all <- 1 + (Unif.type > PI[,1]) + (Unif.type > CDF.w2)

Ksim.F94 <- Ksim.W95 <- Ksim.S95 <-
  cbind(1:length(c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
                   virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ),
  k.all[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
          virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ] )
Ksim.U95 <-
  cbind(1:length(c(virgins.b9,virgins.b10,virgins.b11,
                   virgins.g9,virgins.g10,virgins.g11 ) ),
  k.all[c(virgins.b9,virgins.b10,virgins.b11,
          virgins.g9,virgins.g10,virgins.g11 ) ] )
Ksim.F95 <- Ksim.W96 <- Ksim.S96 <-
  cbind(1:length(c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
                   virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ),
  k.all[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
          virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ] )
Ksim.U96 <- 
  cbind(1:length(c(virgins.b8,virgins.b9,virgins.b10,
                   virgins.g8,virgins.g9,virgins.g10 ) ),
  k.all[c(virgins.b8,virgins.b9,virgins.b10,
          virgins.g8,virgins.g9,virgins.g10 ) ] )
Ksim.F96 <- Ksim.W97 <- Ksim.S97 <-
  cbind(1:length(c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
                   virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ),
  k.all[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
          virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ] )

Ksim.U97 <- Ksim.F97 <- Ksim.W98 <- Ksim.S98 <-
  cbind(
  1:length(c(virgins.b9,virgins.g8,virgins.g9) ),
     k.all[c(virgins.b9,virgins.g8,virgins.g9) ] 
  )

###

### C) FORWARD SIMULATION

# (Simulates out to four years ahead, 15 periods.)

### 1) F94

# Search probabilities:

F.b.F94 <- rbind( 
  Vdiff.b.F9(W.b, h.F94[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9a),
  Vdiff.b.F10(W.b, h.F94[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10a),
  Vdiff.b.F11(W.b, h.F94[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, pop.Pb11, nosupply.b11),
  Vdiff.b.F12(W.b, h.F94[ match(commid[virgins.b12], comlist), ], Xbar.Mb12, pop.Pb12, nosupply.b12)
  )
F.g.F94 <- rbind( 
  Vdiff.g.F9(W.g, h.F94[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9a),
  Vdiff.g.F10(W.g, h.F94[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.F11(W.g, h.F94[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, pop.Pg11, nosupply.g11),
  Vdiff.g.F12(W.g, h.F94[ match(commid[virgins.g12], comlist), ], Xbar.Mg12, pop.Pg12, nosupply.g12)
  )
F.b.F94 <- pnorm(F.b.F94); F.g.F94 <- pnorm(F.g.F94)

# Expected search decisions:

ED.F94[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12), ] <- F.b.F94
ED.F94[c(virgins.g9,virgins.g10,virgins.g11,virgins.g12), ] <- F.g.F94

# Expected arrival rates:

Elam.b9.F94 <- virgins.b9*0
Elam.b9.F94[grd9sep[virgins.b9]] <- Elam.1supply(lambda.b9[1:2],virgins.b9[grd9sep[virgins.b9]],ED.F94)
Elam.b10.F94 <- virgins.b10*0
Elam.b10.F94[grd9sep[virgins.b10]] <- Elam.splitsup(lambda.b10[-3],virgins.b10[grd9sep[virgins.b10]],ED.F94)
Elam.b11.F94 <- Elam.3supply(lambda.b11,virgins.b11,ED.F94)
Elam.b12.F94 <- Elam.2supply(lambda.b12,virgins.b12,ED.F94)

Elam.g9.F94 <- virgins.g9*0
Elam.g9.F94[grd9sep[virgins.g9]] <- Elam.1supply(lambda.g9[1:2],virgins.g9[grd9sep[virgins.g9]],ED.F94)
Elam.g10.F94 <- Elam.3supply(lambda.g10,virgins.g10,ED.F94)
Elam.g11.F94 <- Elam.2supply(lambda.g11,virgins.g11,ED.F94)
Elam.g12.F94 <- Elam.1supply(lambda.g12,virgins.g12,ED.F94)

Elam.F94 <- c(Elam.b9.F94, Elam.b10.F94, Elam.b11.F94, Elam.b12.F94,
              Elam.g9.F94, Elam.g10.F94, Elam.g11.F94, Elam.g12.F94 )

# Match probabilities:

L.F94 <- Elam.F94 * rbind(
  ED.F94[virgins.b9,] ,
  ED.F94[virgins.b10,] ,
  ED.F94[virgins.b11,] ,
  ED.F94[virgins.b12,] ,
  ED.F94[virgins.g9,] ,
  ED.F94[virgins.g10,] ,
  ED.F94[virgins.g11,] ,
  ED.F94[virgins.g12,]  )

# Simulated outcomes:

nonvirg.1sim[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
               virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ] <- L.F94[Ksim.F94] > 
  Unif.y.F94[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
               virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ]

# Aggregates:

hbar.b9 <- tapply(nonvirg.1sim[b9], commid[b9], mean)
hbar.b10 <- tapply(nonvirg.1sim[b10], commid[b10], mean)
hbar.b11 <- tapply(nonvirg.1sim[b11], commid[b11], mean)
hbar.b12 <- tapply(nonvirg.1sim[b12], commid[b12], mean)

hbar.g9 <- tapply(nonvirg.1sim[g9], commid[g9], mean)
hbar.g10 <- tapply(nonvirg.1sim[g10], commid[g10], mean)
hbar.g11 <- tapply(nonvirg.1sim[g11], commid[g11], mean)
hbar.g12 <- tapply(nonvirg.1sim[g12], commid[g12], mean)

h.W95sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.W95sim[is.na(h.W95sim) ] <- 0

### 2) W95

# Search probabilities:

F.b.W95 <- rbind( 
  Vdiff.b.W9(W.b, h.W95sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9a),
  Vdiff.b.W10(W.b, h.W95sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10a),
  Vdiff.b.W11(W.b, h.W95sim[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, pop.Pb11, nosupply.b11),
  Vdiff.b.W12(W.b, h.W95sim[ match(commid[virgins.b12], comlist), ], Xbar.Mb12, pop.Pb12, nosupply.b12)
  )
F.g.W95 <- rbind( 
  Vdiff.g.W9(W.g, h.W95sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9a),
  Vdiff.g.W10(W.g, h.W95sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.W11(W.g, h.W95sim[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, pop.Pg11, nosupply.g11),
  Vdiff.g.W12(W.g, h.W95sim[ match(commid[virgins.g12], comlist), ], Xbar.Mg12, pop.Pg12, nosupply.g12)
  )
F.b.W95 <- pnorm(F.b.W95); F.g.W95 <- pnorm(F.g.W95)

# Expected search decisions:

ED.W95[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12), ] <- F.b.W95
ED.W95[c(virgins.g9,virgins.g10,virgins.g11,virgins.g12), ] <- F.g.W95

ED.W95[nonvirg.1sim,] <- 1

# Expected arrival rates:

Elam.b9.W95 <- virgins.b9*0
Elam.b9.W95[grd9sep[virgins.b9]] <- Elam.1supply(lambda.b9[1:2],virgins.b9[grd9sep[virgins.b9]],ED.W95)
Elam.b10.W95 <- virgins.b10*0
Elam.b10.W95[grd9sep[virgins.b10]] <- Elam.splitsup(lambda.b10[-3],virgins.b10[grd9sep[virgins.b10]],ED.W95)
Elam.b11.W95 <- Elam.3supply(lambda.b11,virgins.b11,ED.W95)
Elam.b12.W95 <- Elam.2supply(lambda.b12,virgins.b12,ED.W95)

Elam.g9.W95 <- virgins.g9*0
Elam.g9.W95[grd9sep[virgins.g9]] <- Elam.1supply(lambda.g9[1:2],virgins.g9[grd9sep[virgins.g9]],ED.W95)
Elam.g10.W95 <- Elam.3supply(lambda.g10,virgins.g10,ED.W95)
Elam.g11.W95 <- Elam.2supply(lambda.g11,virgins.g11,ED.W95)
Elam.g12.W95 <- Elam.1supply(lambda.g12,virgins.g12,ED.W95)

Elam.W95 <- c(Elam.b9.W95, Elam.b10.W95, Elam.b11.W95, Elam.b12.W95,
              Elam.g9.W95, Elam.g10.W95, Elam.g11.W95, Elam.g12.W95 )

# Match probabilities:

L.W95 <- Elam.W95 * rbind(
  ED.W95[virgins.b9,] ,
  ED.W95[virgins.b10,] ,
  ED.W95[virgins.b11,] ,
  ED.W95[virgins.b12,] ,
  ED.W95[virgins.g9,] ,
  ED.W95[virgins.g10,] ,
  ED.W95[virgins.g11,] ,
  ED.W95[virgins.g12,]  )

# Simulated outcomes:

nonvirg.2sim[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
               virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ] <- L.W95[Ksim.W95] >
  Unif.y.W95[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
               virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ]

nonvirg.2sim[nonvirg.1sim] <- TRUE

# Aggregates:

hbar.b9 <- tapply(nonvirg.2sim[b9], commid[b9], mean)
hbar.b10 <- tapply(nonvirg.2sim[b10], commid[b10], mean)
hbar.b11 <- tapply(nonvirg.2sim[b11], commid[b11], mean)
hbar.b12 <- tapply(nonvirg.2sim[b12], commid[b12], mean)

hbar.g9 <- tapply(nonvirg.2sim[g9], commid[g9], mean)
hbar.g10 <- tapply(nonvirg.2sim[g10], commid[g10], mean)
hbar.g11 <- tapply(nonvirg.2sim[g11], commid[g11], mean)
hbar.g12 <- tapply(nonvirg.2sim[g12], commid[g12], mean)

h.S95sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.S95sim[is.na(h.S95sim) ] <- 0

### 3) S95

# Search probabilities:

F.b.S95 <- rbind( 
  Vdiff.b.S9(W.b, h.S95sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9a),
  Vdiff.b.S10(W.b, h.S95sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10a),
  Vdiff.b.S11(W.b, h.S95sim[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, pop.Pb11, nosupply.b11),
  Vdiff.b.S12(W.b, h.S95sim[ match(commid[virgins.b12], comlist), ], Xbar.Mb12, nosupply.b12)
  )
F.g.S95 <- rbind( 
  Vdiff.g.S9(W.g, h.S95sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9a),
  Vdiff.g.S10(W.g, h.S95sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.S11(W.g, h.S95sim[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, pop.Pg11, nosupply.g11),
  Vdiff.g.S12(W.g, h.S95sim[ match(commid[virgins.g12], comlist), ], Xbar.Mg12, nosupply.g12)
  )
F.b.S95 <- pnorm(F.b.S95); F.g.S95 <- pnorm(F.g.S95)

# Expected search decisions:

ED.S95[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12), ] <- F.b.S95
ED.S95[c(virgins.g9,virgins.g10,virgins.g11,virgins.g12), ] <- F.g.S95

ED.S95[nonvirg.2sim,] <- 1

# Expected arrival rates:

Elam.b9.S95 <- virgins.b9*0
Elam.b9.S95[grd9sep[virgins.b9]] <- Elam.1supply(lambda.b9[1:2],virgins.b9[grd9sep[virgins.b9]],ED.S95)
Elam.b10.S95 <- virgins.b10*0
Elam.b10.S95[grd9sep[virgins.b10]] <- Elam.splitsup(lambda.b10[-3],virgins.b10[grd9sep[virgins.b10]],ED.S95)
Elam.b11.S95 <- Elam.3supply(lambda.b11,virgins.b11,ED.S95)
Elam.b12.S95 <- Elam.2supply(lambda.b12,virgins.b12,ED.S95)

Elam.g9.S95 <- virgins.g9*0
Elam.g9.S95[grd9sep[virgins.g9]] <- Elam.1supply(lambda.g9[1:2],virgins.g9[grd9sep[virgins.g9]],ED.S95)
Elam.g10.S95 <- Elam.3supply(lambda.g10,virgins.g10,ED.S95)
Elam.g11.S95 <- Elam.2supply(lambda.g11,virgins.g11,ED.S95)
Elam.g12.S95 <- Elam.1supply(lambda.g12,virgins.g12,ED.S95)

Elam.S95 <- c(Elam.b9.S95, Elam.b10.S95, Elam.b11.S95, Elam.b12.S95,
              Elam.g9.S95, Elam.g10.S95, Elam.g11.S95, Elam.g12.S95 )

# Match probabilities:

L.S95 <- Elam.S95 * rbind(
  ED.S95[virgins.b9,] ,
  ED.S95[virgins.b10,] ,
  ED.S95[virgins.b11,] ,
  ED.S95[virgins.b12,] ,
  ED.S95[virgins.g9,] ,
  ED.S95[virgins.g10,] ,
  ED.S95[virgins.g11,] ,
  ED.S95[virgins.g12,]  )

# Simulated outcomes:

nonvirg.3sim[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
               virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ] <- L.S95[Ksim.S95] >
  Unif.y.S95[c(virgins.b9,virgins.b10,virgins.b11,virgins.b12,
               virgins.g9,virgins.g10,virgins.g11,virgins.g12 ) ]

nonvirg.3sim[nonvirg.2sim] <- TRUE

# Aggregates:

hbar.b9 <- tapply(nonvirg.3sim[b9], commid[b9], mean)
hbar.b10 <- tapply(nonvirg.3sim[b10], commid[b10], mean)
hbar.b11 <- tapply(nonvirg.3sim[b11], commid[b11], mean)
hbar.b12 <- tapply(nonvirg.3sim[b12], commid[b12], mean)

hbar.g9 <- tapply(nonvirg.3sim[g9], commid[g9], mean)
hbar.g10 <- tapply(nonvirg.3sim[g10], commid[g10], mean)
hbar.g11 <- tapply(nonvirg.3sim[g11], commid[g11], mean)
hbar.g12 <- tapply(nonvirg.3sim[g12], commid[g12], mean)

h.U95sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.U95sim[is.na(h.U95sim) ] <- 0

### 4) U95

# Search probabilities:

F.b.U95 <- rbind( 
  Vdiff.b.U9(W.b, h.U95sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9a),
  Vdiff.b.U10(W.b, h.U95sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10a),
  Vdiff.b.U11(W.b, h.U95sim[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, pop.Pb11, nosupply.b11)
  )
F.g.U95 <- rbind( 
  Vdiff.g.U9(W.g, h.U95sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9a),
  Vdiff.g.U10(W.g, h.U95sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.U11(W.g, h.U95sim[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, pop.Pg11, nosupply.g11)
  )
F.b.U95 <- pnorm(F.b.U95); F.g.U95 <- pnorm(F.g.U95)

# Expected search decisions:

ED.U95[c(virgins.b9,virgins.b10,virgins.b11), ] <- F.b.U95
ED.U95[c(virgins.g9,virgins.g10,virgins.g11), ] <- F.g.U95

ED.U95[nonvirg.3sim,] <- 1
ED.U95[c(b12,g12),] <- 0

# Expected arrival rates:

Elam.b9.U95 <- virgins.b9*0
Elam.b9.U95[grd9sep[virgins.b9]] <- Elam.1supply(lambda.b9[1:2],virgins.b9[grd9sep[virgins.b9]],ED.U95)
Elam.b10.U95 <- virgins.b10*0
Elam.b10.U95[grd9sep[virgins.b10]] <- Elam.splitsup(lambda.b10[-3],virgins.b10[grd9sep[virgins.b10]],ED.U95)
Elam.b11.U95 <- Elam.3supply(lambda.b11,virgins.b11,ED.U95)

Elam.g9.U95 <- virgins.g9*0
Elam.g9.U95[grd9sep[virgins.g9]] <- Elam.1supply(lambda.g9[1:2],virgins.g9[grd9sep[virgins.g9]],ED.U95)
Elam.g10.U95 <- Elam.3supply(lambda.g10,virgins.g10,ED.U95)
Elam.g11.U95 <- Elam.2supply(lambda.g11,virgins.g11,ED.U95)

Elam.U95 <- c(Elam.b9.U95, Elam.b10.U95, Elam.b11.U95, 
              Elam.g9.U95, Elam.g10.U95, Elam.g11.U95 )

# Match probabilities:

L.U95 <- Elam.U95 * rbind(
  ED.U95[virgins.b9,] ,
  ED.U95[virgins.b10,] ,
  ED.U95[virgins.b11,] ,
  ED.U95[virgins.g9,] ,
  ED.U95[virgins.g10,] ,
  ED.U95[virgins.g11,]  )

# Simulated outcomes:

nonvirg.4sim[c(virgins.b9,virgins.b10,virgins.b11,
               virgins.g9,virgins.g10,virgins.g11 ) ] <- L.U95[Ksim.U95] > 
  Unif.y.U95[c(virgins.b9,virgins.b10,virgins.b11,
               virgins.g9,virgins.g10,virgins.g11 ) ]

nonvirg.4sim[nonvirg.3sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.4sim[b8], commid[b8], mean)
hbar.b10 <- tapply(nonvirg.4sim[b9], commid[b9], mean)
hbar.b11 <- tapply(nonvirg.4sim[b10], commid[b10], mean)
hbar.b12 <- tapply(nonvirg.4sim[b11], commid[b11], mean)

hbar.g9  <- tapply(nonvirg.4sim[g8], commid[g8], mean)
hbar.g10 <- tapply(nonvirg.4sim[g9], commid[g9], mean)
hbar.g11 <- tapply(nonvirg.4sim[g10], commid[g10], mean)
hbar.g12 <- tapply(nonvirg.4sim[g11], commid[g11], mean)

h.F95sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.F95sim[is.na(h.F95sim) ] <- 0

### 5) F95

# Search probabilities:

F.b.F95 <- rbind( 
  Vdiff.b.F9(W.b, h.F95sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.F10(W.b, h.F95sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.F11(W.b, h.F95sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10),
  Vdiff.b.F12(W.b, h.F95sim[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, pop.Pb11, nosupply.b11)
  )
F.g.F95 <- rbind( 
  Vdiff.g.F9(W.g, h.F95sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.F10(W.g, h.F95sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.F11(W.g, h.F95sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.F12(W.g, h.F95sim[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, pop.Pg11, nosupply.g11)
  )
F.b.F95 <- pnorm(F.b.F95); F.g.F95 <- pnorm(F.g.F95)

# Expected search decisions:

ED.F95[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11), ] <- F.b.F95
ED.F95[c(virgins.g8,virgins.g9,virgins.g10,virgins.g11), ] <- F.g.F95

ED.F95[nonvirg.4sim,] <- 1

# Expected arrival rates:

Elam.b8.F95 <- virgins.b8*0
Elam.b8.F95[grd9sep[virgins.b8]] <- Elam.1supply(lambda.b9[1:2],virgins.b8[grd9sep[virgins.b8]],ED.F95)
Elam.b9.F95 <- virgins.b9*0
Elam.b9.F95[grd9sep[virgins.b9]] <- Elam.splitsup(lambda.b10[-3],virgins.b9[grd9sep[virgins.b9]],ED.F95)
Elam.b10.F95 <- Elam.3supply(lambda.b11,virgins.b10,ED.F95)
Elam.b11.F95 <- Elam.2supply(lambda.b12,virgins.b11,ED.F95)

Elam.g8.F95 <- virgins.g8*0
Elam.g8.F95[grd9sep[virgins.g8]] <- Elam.1supply(lambda.g9[1:2],virgins.g8[grd9sep[virgins.g8]],ED.F95)
Elam.g9.F95 <-  Elam.3supply(lambda.g10,virgins.g9,ED.F95)
Elam.g10.F95 <- Elam.2supply(lambda.g11,virgins.g10,ED.F95)
Elam.g11.F95 <- Elam.1supply(lambda.g12,virgins.g11,ED.F95)

Elam.F95 <- c(Elam.b8.F95, Elam.b9.F95, Elam.b10.F95, Elam.b11.F95,
              Elam.g8.F95, Elam.g9.F95, Elam.g10.F95, Elam.g11.F95 )

# Match probabilities:

L.F95 <- Elam.F95 * rbind(
  ED.F95[virgins.b8,] ,
  ED.F95[virgins.b9,] ,
  ED.F95[virgins.b10,] ,
  ED.F95[virgins.b11,] ,
  ED.F95[virgins.g8,] ,
  ED.F95[virgins.g9,] ,
  ED.F95[virgins.g10,] ,
  ED.F95[virgins.g11,]  )

# Simulated outcomes:

nonvirg.5sim[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
               virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ] <- L.F95[Ksim.F95] > 
  Unif.y.F95[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
               virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ]

nonvirg.5sim[nonvirg.4sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.5sim[b8], commid[b8], mean)
hbar.b10 <- tapply(nonvirg.5sim[b9], commid[b9], mean)
hbar.b11 <- tapply(nonvirg.5sim[b10], commid[b10], mean)
hbar.b12 <- tapply(nonvirg.5sim[b11], commid[b11], mean)

hbar.g9  <- tapply(nonvirg.5sim[g8], commid[g8], mean)
hbar.g10 <- tapply(nonvirg.5sim[g9], commid[g9], mean)
hbar.g11 <- tapply(nonvirg.5sim[g10], commid[g10], mean)
hbar.g12 <- tapply(nonvirg.5sim[g11], commid[g11], mean)

h.W96sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.W96sim[is.na(h.W96sim) ] <- 0

### 6) W96

# Search probabilities:

F.b.W96 <- rbind( 
  Vdiff.b.W9(W.b, h.W96sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.W10(W.b, h.W96sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.W11(W.b, h.W96sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10),
  Vdiff.b.W12(W.b, h.W96sim[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, pop.Pb11, nosupply.b11)
  )
F.g.W96 <- rbind( 
  Vdiff.g.W9(W.g, h.W96sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.W10(W.g, h.W96sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.W11(W.g, h.W96sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.W12(W.g, h.W96sim[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, pop.Pg11, nosupply.g11)
  )
F.b.W96 <- pnorm(F.b.W96); F.g.W96 <- pnorm(F.g.W96)

# Expected search decisions:

ED.W96[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11), ] <- F.b.W96
ED.W96[c(virgins.g8,virgins.g9,virgins.g10,virgins.g11), ] <- F.g.W96

ED.W96[nonvirg.5sim,] <- 1

# Expected arrival rates:

Elam.b8.W96 <- virgins.b8*0
Elam.b8.W96[grd9sep[virgins.b8]] <- Elam.1supply(lambda.b9[1:2],virgins.b8[grd9sep[virgins.b8]],ED.W96)
Elam.b9.W96 <- virgins.b9*0
Elam.b9.W96[grd9sep[virgins.b9]] <- Elam.splitsup(lambda.b10[-3],virgins.b9[grd9sep[virgins.b9]],ED.W96)
Elam.b10.W96 <- Elam.3supply(lambda.b11,virgins.b10,ED.W96)
Elam.b11.W96 <- Elam.2supply(lambda.b12,virgins.b11,ED.W96)

Elam.g8.W96 <- virgins.g8*0
Elam.g8.W96[grd9sep[virgins.g8]] <- Elam.1supply(lambda.g9[1:2],virgins.g8[grd9sep[virgins.g8]],ED.W96)
Elam.g9.W96 <-  Elam.3supply(lambda.g10,virgins.g9,ED.W96)
Elam.g10.W96 <- Elam.2supply(lambda.g11,virgins.g10,ED.W96)
Elam.g11.W96 <- Elam.1supply(lambda.g12,virgins.g11,ED.W96)

Elam.W96 <- c(Elam.b8.W96, Elam.b9.W96, Elam.b10.W96, Elam.b11.W96,
              Elam.g8.W96, Elam.g9.W96, Elam.g10.W96, Elam.g11.W96 )

# Match probabilities:

L.W96 <- Elam.W96 * rbind(
  ED.W96[virgins.b8,] ,
  ED.W96[virgins.b9,] ,
  ED.W96[virgins.b10,] ,
  ED.W96[virgins.b11,] ,
  ED.W96[virgins.g8,] ,
  ED.W96[virgins.g9,] ,
  ED.W96[virgins.g10,] ,
  ED.W96[virgins.g11,]  )

# Simulated outcomes:

nonvirg.6sim[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
               virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ] <- L.W96[Ksim.W96] > 
  Unif.y.W96[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
               virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ]

nonvirg.6sim[nonvirg.5sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.6sim[b8], commid[b8], mean)
hbar.b10 <- tapply(nonvirg.6sim[b9], commid[b9], mean)
hbar.b11 <- tapply(nonvirg.6sim[b10], commid[b10], mean)
hbar.b12 <- tapply(nonvirg.6sim[b11], commid[b11], mean)

hbar.g9  <- tapply(nonvirg.6sim[g8], commid[g8], mean)
hbar.g10 <- tapply(nonvirg.6sim[g9], commid[g9], mean)
hbar.g11 <- tapply(nonvirg.6sim[g10], commid[g10], mean)
hbar.g12 <- tapply(nonvirg.6sim[g11], commid[g11], mean)

h.S96sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.S96sim[is.na(h.S96sim) ] <- 0

### 7) S96

# Search probabilities:

F.b.S96 <- rbind( 
  Vdiff.b.S9(W.b, h.S96sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.S10(W.b, h.S96sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.S11(W.b, h.S96sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10),
  Vdiff.b.S12(W.b, h.S96sim[ match(commid[virgins.b11], comlist), ], Xbar.Mb11, nosupply.b11)
  )
F.g.S96 <- rbind( 
  Vdiff.g.S9(W.g, h.S96sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.S10(W.g, h.S96sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.S11(W.g, h.S96sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10),
  Vdiff.g.S12(W.g, h.S96sim[ match(commid[virgins.g11], comlist), ], Xbar.Mg11, nosupply.g11)
  )
F.b.S96 <- pnorm(F.b.S96); F.g.S96 <- pnorm(F.g.S96)

# Expected search decisions:

ED.S96[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11), ] <- F.b.S96
ED.S96[c(virgins.g8,virgins.g9,virgins.g10,virgins.g11), ] <- F.g.S96

ED.S96[nonvirg.6sim,] <- 1

# Expected arrival rates:

Elam.b8.S96 <- virgins.b8*0
Elam.b8.S96[grd9sep[virgins.b8]] <- Elam.1supply(lambda.b9[1:2],virgins.b8[grd9sep[virgins.b8]],ED.S96)
Elam.b9.S96 <- virgins.b9*0
Elam.b9.S96[grd9sep[virgins.b9]] <- Elam.splitsup(lambda.b10[-3],virgins.b9[grd9sep[virgins.b9]],ED.S96)
Elam.b10.S96 <- Elam.3supply(lambda.b11,virgins.b10,ED.S96)
Elam.b11.S96 <- Elam.2supply(lambda.b12,virgins.b11,ED.S96)

Elam.g8.S96 <- virgins.g8*0
Elam.g8.S96[grd9sep[virgins.g8]] <- Elam.1supply(lambda.g9[1:2],virgins.g8[grd9sep[virgins.g8]],ED.S96)
Elam.g9.S96 <-  Elam.3supply(lambda.g10,virgins.g9,ED.S96)
Elam.g10.S96 <- Elam.2supply(lambda.g11,virgins.g10,ED.S96)
Elam.g11.S96 <- Elam.1supply(lambda.g12,virgins.g11,ED.S96)

Elam.S96 <- c(Elam.b8.S96, Elam.b9.S96, Elam.b10.S96, Elam.b11.S96,
              Elam.g8.S96, Elam.g9.S96, Elam.g10.S96, Elam.g11.S96 )

# Match probabilities:

L.S96 <- Elam.S96 * rbind(
  ED.S96[virgins.b8,] ,
  ED.S96[virgins.b9,] ,
  ED.S96[virgins.b10,] ,
  ED.S96[virgins.b11,] ,
  ED.S96[virgins.g8,] ,
  ED.S96[virgins.g9,] ,
  ED.S96[virgins.g10,] ,
  ED.S96[virgins.g11,]  )

# Simulated outcomes:

nonvirg.7sim[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
               virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ] <- L.S96[Ksim.S96] >
  Unif.y.S96[c(virgins.b8,virgins.b9,virgins.b10,virgins.b11,
               virgins.g8,virgins.g9,virgins.g10,virgins.g11 ) ]

nonvirg.7sim[nonvirg.6sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.7sim[b8], commid[b8], mean)
hbar.b10 <- tapply(nonvirg.7sim[b9], commid[b9], mean)
hbar.b11 <- tapply(nonvirg.7sim[b10], commid[b10], mean)
hbar.b12 <- tapply(nonvirg.7sim[b11], commid[b11], mean)

hbar.g9  <- tapply(nonvirg.7sim[g8], commid[g8], mean)
hbar.g10 <- tapply(nonvirg.7sim[g9], commid[g9], mean)
hbar.g11 <- tapply(nonvirg.7sim[g10], commid[g10], mean)
hbar.g12 <- tapply(nonvirg.7sim[g11], commid[g11], mean)

h.U96sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.U96sim[is.na(h.U96sim) ] <- 0

### 8) U96

# Search probabilities:

F.b.U96 <- rbind( 
  Vdiff.b.U9(W.b, h.U96sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.U10(W.b, h.U96sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.U11(W.b, h.U96sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10)
  )
F.g.U96 <- rbind( 
  Vdiff.g.U9(W.g, h.U96sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.U10(W.g, h.U96sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.U11(W.g, h.U96sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10)
  )
F.b.U96 <- pnorm(F.b.U96); F.g.U96 <- pnorm(F.g.U96)

# Expected search decisions:

ED.U96[c(virgins.b8,virgins.b9,virgins.b10), ] <- F.b.U96
ED.U96[c(virgins.g8,virgins.g9,virgins.g10), ] <- F.g.U96

ED.U96[nonvirg.7sim,] <- 1
ED.U96[c(b11,g11),] <- 0

# Expected arrival rates:

Elam.b8.U96 <- virgins.b8*0
Elam.b8.U96[grd9sep[virgins.b8]] <- Elam.1supply(lambda.b9[1:2],virgins.b8[grd9sep[virgins.b8]],ED.U96)
Elam.b9.U96 <- virgins.b9*0
Elam.b9.U96[grd9sep[virgins.b9]] <- Elam.splitsup(lambda.b10[-3],virgins.b9[grd9sep[virgins.b9]],ED.U96)
Elam.b10.U96 <- Elam.3supply(lambda.b11,virgins.b10,ED.U96)

Elam.g8.U96 <- virgins.g8*0
Elam.g8.U96[grd9sep[virgins.g8]] <- Elam.1supply(lambda.g9[1:2],virgins.g8[grd9sep[virgins.g8]],ED.U96)
Elam.g9.U96 <-  Elam.3supply(lambda.g10,virgins.g9,ED.U96)
Elam.g10.U96 <- Elam.2supply(lambda.g11,virgins.g10,ED.U96)
Elam.g11.U96 <- Elam.1supply(lambda.g12,virgins.g11,ED.U96)

Elam.U96 <- c(Elam.b8.U96, Elam.b9.U96, Elam.b10.U96,
              Elam.g8.U96, Elam.g9.U96, Elam.g10.U96 )

# Match probabilities:

L.U96 <- Elam.U96 * rbind(
  ED.U96[virgins.b8,] ,
  ED.U96[virgins.b9,] ,
  ED.U96[virgins.b10,] ,
  ED.U96[virgins.g8,] ,
  ED.U96[virgins.g9,] ,
  ED.U96[virgins.g10,] )

# Simulated outcomes:

nonvirg.8sim[c(virgins.b8,virgins.b9,virgins.b10,
               virgins.g8,virgins.g9,virgins.g10 ) ] <- L.U96[Ksim.U96] > 
  Unif.y.U96[c(virgins.b8,virgins.b9,virgins.b10,
               virgins.g8,virgins.g9,virgins.g10 ) ]

nonvirg.8sim[nonvirg.7sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.8sim[b7], commid[b7], mean)
hbar.b10 <- tapply(nonvirg.8sim[b8], commid[b8], mean)
hbar.b11 <- tapply(nonvirg.8sim[b9], commid[b9], mean)
hbar.b12 <- tapply(nonvirg.8sim[b10], commid[b10], mean)

hbar.g9  <- tapply(nonvirg.8sim[g7], commid[g7], mean)
hbar.g10 <- tapply(nonvirg.8sim[g8], commid[g8], mean)
hbar.g11 <- tapply(nonvirg.8sim[g9], commid[g9], mean)
hbar.g12 <- tapply(nonvirg.8sim[g10], commid[g10], mean)

h.F96sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.F96sim[is.na(h.F96sim) ] <- 0

### 9) F96

# Search probabilities:

F.b.F96 <- rbind( 
  Vdiff.b.F9(W.b, h.F96sim[ match(commid[virgins.b7], comlist), ], Xbar.Mb7, pop.Pb7, nosupply.b7),
  Vdiff.b.F10(W.b, h.F96sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.F11(W.b, h.F96sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.F12(W.b, h.F96sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10)
  )

F.g.F96 <- rbind( 
  Vdiff.g.F9(W.g, h.F96sim[ match(commid[virgins.g7], comlist), ], Xbar.Mg7, pop.Pg7, nosupply.g7),
  Vdiff.g.F10(W.g, h.F96sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.F11(W.g, h.F96sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.F12(W.g, h.F96sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10)
  )
F.b.F96 <- pnorm(F.b.F96); F.g.F96 <- pnorm(F.g.F96)

# Expected search decisions:

ED.F96[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10), ] <- F.b.F96
ED.F96[c(virgins.g7,virgins.g8,virgins.g9,virgins.g10), ] <- F.g.F96

ED.F96[nonvirg.8sim,] <- 1

# Expected arrival rates:

Elam.b7.F96 <- Elam.splitsup(lambda.b9,virgins.b7,ED.F96)
Elam.b8.F96 <- Elam.3supply(lambda.b10,virgins.b8,ED.F96)
Elam.b9.F96 <- Elam.3supply(lambda.b11,virgins.b9,ED.F96)
Elam.b10.F96 <- Elam.2supply(lambda.b12,virgins.b10,ED.F96)

Elam.g7.F96 <- Elam.3supply(lambda.g9,virgins.g7,ED.F96)
Elam.g8.F96 <- Elam.3supply(lambda.g10,virgins.g8,ED.F96)
Elam.g9.F96 <- Elam.2supply(lambda.g11,virgins.g9,ED.F96)
Elam.g10.F96 <- Elam.1supply(lambda.g12,virgins.g10,ED.F96)

Elam.F96 <- c(Elam.b7.F96, Elam.b8.F96, Elam.b9.F96, Elam.b10.F96,
              Elam.g7.F96, Elam.g8.F96, Elam.g9.F96, Elam.g10.F96 )

# Match probabilities:

L.F96 <- Elam.F96 * rbind(
  ED.F96[virgins.b7,] ,
  ED.F96[virgins.b8,] ,
  ED.F96[virgins.b9,] ,
  ED.F96[virgins.b10,] ,
  ED.F96[virgins.g7,] ,
  ED.F96[virgins.g8,] ,
  ED.F96[virgins.g9,] ,
  ED.F96[virgins.g10,] )

# Simulated outcomes:

nonvirg.9sim[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
               virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ] <- L.F96[Ksim.F96] > 
  Unif.y.F96[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
               virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ]

nonvirg.9sim[nonvirg.8sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.9sim[b7], commid[b7], mean)
hbar.b10 <- tapply(nonvirg.9sim[b8], commid[b8], mean)
hbar.b11 <- tapply(nonvirg.9sim[b9], commid[b9], mean)
hbar.b12 <- tapply(nonvirg.9sim[b10], commid[b10], mean)

hbar.g9  <- tapply(nonvirg.9sim[g7], commid[g7], mean)
hbar.g10 <- tapply(nonvirg.9sim[g8], commid[g8], mean)
hbar.g11 <- tapply(nonvirg.9sim[g9], commid[g9], mean)
hbar.g12 <- tapply(nonvirg.9sim[g10], commid[g10], mean)

h.W97sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.W97sim[is.na(h.W97sim) ] <- 0

### 10) W97

# Search probabilities:

F.b.W97 <- rbind( 
  Vdiff.b.W9(W.b, h.W97sim[ match(commid[virgins.b7], comlist), ], Xbar.Mb7, pop.Pb7, nosupply.b7),
  Vdiff.b.W10(W.b, h.W97sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.W11(W.b, h.W97sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.W12(W.b, h.W97sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, pop.Pb10, nosupply.b10)
  )
F.g.W97 <- rbind( 
  Vdiff.g.W9(W.g, h.W97sim[ match(commid[virgins.g7], comlist), ], Xbar.Mg7, pop.Pg7, nosupply.g7),
  Vdiff.g.W10(W.g, h.W97sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.W11(W.g, h.W97sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.W12(W.g, h.W97sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, pop.Pg10, nosupply.g10)
  )
F.b.W97 <- pnorm(F.b.W97); F.g.W97 <- pnorm(F.g.W97)

# Expected search decisions:

ED.W97[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10), ] <- F.b.W97
ED.W97[c(virgins.g7,virgins.g8,virgins.g9,virgins.g10), ] <- F.g.W97

ED.W97[nonvirg.9sim,] <- 1

# Expected arrival rates:

Elam.b7.W97 <- Elam.splitsup(lambda.b9,virgins.b7,ED.W97)
Elam.b8.W97 <- Elam.3supply(lambda.b10,virgins.b8,ED.W97)
Elam.b9.W97 <- Elam.3supply(lambda.b11,virgins.b9,ED.W97)
Elam.b10.W97 <- Elam.2supply(lambda.b12,virgins.b10,ED.W97)

Elam.g7.W97 <- Elam.3supply(lambda.g9,virgins.g7,ED.W97)
Elam.g8.W97 <- Elam.3supply(lambda.g10,virgins.g8,ED.W97)
Elam.g9.W97 <- Elam.2supply(lambda.g11,virgins.g9,ED.W97)
Elam.g10.W97 <- Elam.1supply(lambda.g12,virgins.g10,ED.W97)

Elam.W97 <- c(Elam.b7.W97, Elam.b8.W97, Elam.b9.W97, Elam.b10.W97,
              Elam.g7.W97, Elam.g8.W97, Elam.g9.W97, Elam.g10.W97 )

# Match probabilities:

L.W97 <- Elam.W97 * rbind(
  ED.W97[virgins.b7,] ,
  ED.W97[virgins.b8,] ,
  ED.W97[virgins.b9,] ,
  ED.W97[virgins.b10,] ,
  ED.W97[virgins.g7,] ,
  ED.W97[virgins.g8,] ,
  ED.W97[virgins.g9,] ,
  ED.W97[virgins.g10,] )

# Simulated outcomes:

nonvirg.10sim[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
                virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ] <- L.W97[Ksim.W97] > 
   Unif.y.W97[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
                virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ]

nonvirg.10sim[nonvirg.9sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.10sim[b7], commid[b7], mean)
hbar.b10 <- tapply(nonvirg.10sim[b8], commid[b8], mean)
hbar.b11 <- tapply(nonvirg.10sim[b9], commid[b9], mean)
hbar.b12 <- tapply(nonvirg.10sim[b10], commid[b10], mean)

hbar.g9  <- tapply(nonvirg.10sim[g7], commid[g7], mean)
hbar.g10 <- tapply(nonvirg.10sim[g8], commid[g8], mean)
hbar.g11 <- tapply(nonvirg.10sim[g9], commid[g9], mean)
hbar.g12 <- tapply(nonvirg.10sim[g10], commid[g10], mean)

h.S97sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.S97sim[is.na(h.S97sim) ] <- 0

### 11) S97

# Search probabilities:

F.b.S97 <- rbind( 
  Vdiff.b.S9(W.b, h.S97sim[ match(commid[virgins.b7], comlist), ], Xbar.Mb7, pop.Pb7, nosupply.b7),
  Vdiff.b.S10(W.b, h.S97sim[ match(commid[virgins.b8], comlist), ], Xbar.Mb8, pop.Pb8, nosupply.b8),
  Vdiff.b.S11(W.b, h.S97sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9),
  Vdiff.b.S12(W.b, h.S97sim[ match(commid[virgins.b10], comlist), ], Xbar.Mb10, nosupply.b10)
  )
F.g.S97 <- rbind( 
  Vdiff.g.S9(W.g, h.S97sim[ match(commid[virgins.g7], comlist), ], Xbar.Mg7, pop.Pg7, nosupply.g7),
  Vdiff.g.S10(W.g, h.S97sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.S11(W.g, h.S97sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9),
  Vdiff.g.S12(W.g, h.S97sim[ match(commid[virgins.g10], comlist), ], Xbar.Mg10, nosupply.g10)
  )
F.b.S97 <- pnorm(F.b.S97); F.g.S97 <- pnorm(F.g.S97)

# Expected search decisions:

ED.S97[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10), ] <- F.b.S97
ED.S97[c(virgins.g7,virgins.g8,virgins.g9,virgins.g10), ] <- F.g.S97

ED.S97[nonvirg.10sim,] <- 1

# Expected arrival rates:

Elam.b7.S97 <- Elam.splitsup(lambda.b9,virgins.b7,ED.S97)
Elam.b8.S97 <- Elam.3supply(lambda.b10,virgins.b8,ED.S97)
Elam.b9.S97 <- Elam.3supply(lambda.b11,virgins.b9,ED.S97)
Elam.b10.S97 <- Elam.2supply(lambda.b12,virgins.b10,ED.S97)

Elam.g7.S97 <- Elam.3supply(lambda.g9,virgins.g7,ED.S97)
Elam.g8.S97 <- Elam.3supply(lambda.g10,virgins.g8,ED.S97)
Elam.g9.S97 <- Elam.2supply(lambda.g11,virgins.g9,ED.S97)
Elam.g10.S97 <- Elam.1supply(lambda.g12,virgins.g10,ED.S97)

Elam.S97 <- c(Elam.b7.S97, Elam.b8.S97, Elam.b9.S97, Elam.b10.S97,
              Elam.g7.S97, Elam.g8.S97, Elam.g9.S97, Elam.g10.S97 )

# Match probabilities:

L.S97 <- Elam.S97 * rbind(
  ED.S97[virgins.b7,] ,
  ED.S97[virgins.b8,] ,
  ED.S97[virgins.b9,] ,
  ED.S97[virgins.b10,] ,
  ED.S97[virgins.g7,] ,
  ED.S97[virgins.g8,] ,
  ED.S97[virgins.g9,] ,
  ED.S97[virgins.g10,] )

# Simulated outcomes:

nonvirg.11sim[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
                virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ] <-  L.S97[Ksim.S97] > 
   Unif.y.S97[c(virgins.b7,virgins.b8,virgins.b9,virgins.b10,
                virgins.g7,virgins.g8,virgins.g9,virgins.g10 ) ]

nonvirg.11sim[nonvirg.10sim] <- TRUE

# Aggregates:

hbar.b9  <- tapply(nonvirg.11sim[b7], commid[b7], mean)
hbar.b10 <- tapply(nonvirg.11sim[b8], commid[b8], mean)
hbar.b11 <- tapply(nonvirg.11sim[b9], commid[b9], mean)
hbar.b12 <- tapply(nonvirg.11sim[b10], commid[b10], mean)

hbar.g9  <- tapply(nonvirg.11sim[g7], commid[g7], mean)
hbar.g10 <- tapply(nonvirg.11sim[g8], commid[g8], mean)
hbar.g11 <- tapply(nonvirg.11sim[g9], commid[g9], mean)
hbar.g12 <- tapply(nonvirg.11sim[g10], commid[g10], mean)

h.U97sim <- cbind(hbar.b9[comlist],hbar.b10[comlist],hbar.b11[comlist],hbar.b12[comlist],
                  hbar.g9[comlist],hbar.g10[comlist],hbar.g11[comlist],hbar.g12[comlist] )
h.U97sim[is.na(h.U97sim) ] <- 0

### 12) U97

# Search probabilities:

F.b.U97 <- rbind( 
  Vdiff.b.U11(W.b, h.U97sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9)
  )
F.g.U97 <- rbind( 
  Vdiff.g.U10(W.g, h.U97sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.U11(W.g, h.U97sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9)
  )
F.b.U97 <- pnorm(F.b.U97); F.g.U97 <- pnorm(F.g.U97)

# Expected search decisions:

ED.U97[  virgins.b9, ] <- F.b.U97
ED.U97[c(virgins.g8,virgins.g9), ] <- F.g.U97

ED.U97[nonvirg.11sim,] <- 1
ED.U97[c(b10,g10),] <- 0

# Expected arrival rates:

Elam.b9.U97 <- Elam.3supply(lambda.b11,virgins.b9,ED.U97)

Elam.g8.U97 <- Elam.3supply(lambda.g10,virgins.g8,ED.U97)
Elam.g9.U97 <- Elam.2supply(lambda.g11,virgins.g9,ED.U97)

Elam.U97 <- c(Elam.b9.U97, Elam.g8.U97, Elam.g9.U97)

# Match probabilities:

L.U97 <- Elam.U97 * rbind(
  ED.U97[virgins.b9,],
  ED.U97[virgins.g8,],
  ED.U97[virgins.g9,] )

# Simulated outcomes:

nonvirg.12sim[c(virgins.b9,virgins.g8,virgins.g9) ] <-  L.U97[Ksim.U97] > 
   Unif.y.U97[c(virgins.b9,virgins.g8,virgins.g9) ]

nonvirg.12sim[nonvirg.11sim] <- TRUE

# Aggregates:

h.F97sim <- psi.chg(h.U97sim)

### 13) F97

# Search probabilities:

F.b.F97 <- rbind( 
  Vdiff.b.F12(W.b, h.F97sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9)
  )
F.g.F97 <- rbind( 
  Vdiff.g.F11(W.g, h.F97sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.F12(W.g, h.F97sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9)
  )
F.b.F97 <- pnorm(F.b.F97); F.g.F97 <- pnorm(F.g.F97)

# Expected search decisions:

ED.F97[  virgins.b9, ] <- F.b.F97
ED.F97[c(virgins.g8,virgins.g9), ] <- F.g.F97

ED.F97[nonvirg.12sim,] <- 1

# Expected arrival rates:

Elam.b9.F97 <- Elam.2supply(lambda.b12,virgins.b9,ED.F97)

Elam.g8.F97 <- Elam.2supply(lambda.g11,virgins.g8,ED.F97)
Elam.g9.F97 <- Elam.1supply(lambda.g12,virgins.g9,ED.F97)

Elam.F97 <- c(Elam.b9.F97, Elam.g8.F97, Elam.g9.F97)

# Match probabilities:

L.F97 <- Elam.F97 * rbind(
  ED.F97[virgins.b9,],
  ED.F97[virgins.g8,],
  ED.F97[virgins.g9,] )

# Simulated outcomes:

nonvirg.13sim[c(virgins.b9,virgins.g8,virgins.g9) ] <-  L.F97[Ksim.F97] > 
   Unif.y.F97[c(virgins.b9,virgins.g8,virgins.g9) ]

nonvirg.13sim[nonvirg.12sim] <- TRUE

# Aggregates:

h.W98sim <- psi.qtr(h.F97sim)

### 14) W98

# Search probabilities:

F.b.W98 <- rbind( 
  Vdiff.b.W12(W.b, h.W98sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, pop.Pb9, nosupply.b9)
  )
F.g.W98 <- rbind( 
  Vdiff.g.W11(W.g, h.W98sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.W12(W.g, h.W98sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, pop.Pg9, nosupply.g9)
  )
F.b.W98 <- pnorm(F.b.W98); F.g.W98 <- pnorm(F.g.W98)

# Expected search decisions:

ED.W98[  virgins.b9, ] <- F.b.W98
ED.W98[c(virgins.g8,virgins.g9), ] <- F.g.W98

ED.W98[nonvirg.13sim,] <- 1

# Expected arrival rates:

Elam.b9.W98 <- Elam.2supply(lambda.b12,virgins.b9,ED.W98)

Elam.g8.W98 <- Elam.2supply(lambda.g11,virgins.g8,ED.W98)
Elam.g9.W98 <- Elam.1supply(lambda.g12,virgins.g9,ED.W98)

Elam.W98 <- c(Elam.b9.W98, Elam.g8.W98, Elam.g9.W98)

# Match probabilities:

L.W98 <- Elam.W98 * rbind(
  ED.W98[virgins.b9,],
  ED.W98[virgins.g8,],
  ED.W98[virgins.g9,] )

# Simulated outcomes:

nonvirg.14sim[c(virgins.b9,virgins.g8,virgins.g9) ] <-  L.W98[Ksim.W98] > 
   Unif.y.W98[c(virgins.b9,virgins.g8,virgins.g9) ]

nonvirg.14sim[nonvirg.13sim] <- TRUE

# Aggregates:

h.S98sim <- psi.qtr(h.W98sim)

### 15) S98

# Search probabilities:

F.b.S98 <- rbind( 
  Vdiff.b.S12(W.b, h.S98sim[ match(commid[virgins.b9], comlist), ], Xbar.Mb9, nosupply.b9)
  )
F.g.S98 <- rbind( 
  Vdiff.g.S11(W.g, h.S98sim[ match(commid[virgins.g8], comlist), ], Xbar.Mg8, pop.Pg8, nosupply.g8),
  Vdiff.g.S12(W.g, h.S98sim[ match(commid[virgins.g9], comlist), ], Xbar.Mg9, nosupply.g9)
  )
F.b.S98 <- pnorm(F.b.S98); F.g.S98 <- pnorm(F.g.S98)

# Expected search decisions:

ED.S98[  virgins.b9, ] <- F.b.S98
ED.S98[c(virgins.g8,virgins.g9), ] <- F.g.S98

ED.S98[nonvirg.14sim,] <- 1

# Expected arrival rates:

Elam.b9.S98 <- Elam.2supply(lambda.b12,virgins.b9,ED.S98)

Elam.g8.S98 <- Elam.2supply(lambda.g11,virgins.g8,ED.S98)
Elam.g9.S98 <- Elam.1supply(lambda.g12,virgins.g9,ED.S98)

Elam.S98 <- c(Elam.b9.S98, Elam.g8.S98, Elam.g9.S98)

# Match probabilities:

L.S98 <- Elam.S98 * rbind(
  ED.S98[virgins.b9,],
  ED.S98[virgins.g8,],
  ED.S98[virgins.g9,] )

# Simulated outcomes:

nonvirg.15sim[c(virgins.b9,virgins.g8,virgins.g9) ] <-  L.S98[Ksim.S98] > 
   Unif.y.S98[c(virgins.b9,virgins.g8,virgins.g9) ]

nonvirg.15sim[nonvirg.14sim] <- TRUE

###

### D) RESULTS

output <- as.list(1:2)
names(output) <- c("agg","ind")

aggregate(cbind(nonvirg_0,nonvirg.1sim,nonvirg.2sim,nonvirg.3sim,
  nonvirg.4sim,nonvirg.5sim,nonvirg.6sim,nonvirg.7sim,
  nonvirg.8sim,nonvirg.9sim,nonvirg.10sim,nonvirg.11sim,
  nonvirg.12sim,nonvirg.13sim,nonvirg.14sim,nonvirg.15sim),
  by=list(cohort,bio_sex), mean) -> output[[1]]

cbind(nonvirg_0,nonvirg.1sim,nonvirg.2sim,nonvirg.3sim,
  nonvirg.4sim,nonvirg.5sim,nonvirg.6sim,nonvirg.7sim,
  nonvirg.8sim,nonvirg.9sim,nonvirg.10sim,nonvirg.11sim,
  nonvirg.12sim,nonvirg.13sim,nonvirg.14sim,nonvirg.15sim) -> output[[2]]

output

}  #  END supersim  (NO 9TH GRADE, 7/23/09)
