### EVALUATION FUNCTION

Spr12 <- function() {

### 1) INDIVIDUAL DECISION

# Threshold:

valuediff.b <- a.b12 + a1.b*(15 + B*16/(1-B))/10 + g.b*h.b[,p.b12]/(1-B*d) + W.b[k.b]/(1-B) -
  B*v.b[k.b]
valuediff.g <- a.g12 + a1.g*(15 + B*16/(1-B))/10 + g.g*h.g[,p.g12]/(1-B*d) + W.g[k.g]/(1-B) -
  B*v.g[k.g]

### 2) SUPPLY

# Storage:

Elam.b <- numeric(Pts) + as.vector( Match(lambda.b12)(cbind(0,0) ) )
Elam.g <- numeric(Pts) + as.vector( Match(lambda.g12)(0) )

# Boys:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mb[i,1]; pop.m2 <- pop.Mb[i,2]; pop.m3 <- pop.Mb[i,3]
  Nbar.m1 <- 0; Nbar.m2 <- 0; Nbar.m3 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mb[[i]][[1]] %*% Dpred.g.S12 + Dp2.g.S12*h.b[i,m.b12[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mb[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # M2) Grade below:
if (pop.m2 > 0)  {
  # Probabilities:
Dpred.m2 <- aXiXj.Mb[[i]][[2]] %*% Dpred.g.S11 + Dp2.g.S11*h.b[i,m.b12[2]]
  # Simulations:
D.m2 <- ( as.vector(Dpred.m2) > unif.Mb[[i]][[2]] )
  # Supplies:
N.m2 <- colSums(D.m2, na.rm=TRUE)
Nbar.m2 <- N.m2/pop.m2
    }
  # Match function:
Elam.b[i] <- mean( Match(lambda.b12)(cbind(Nbar.m1,Nbar.m2) ) ) 
  }

# Girls:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mg[i,1]
  Nbar.m1 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mg[[i]][[1]] %*% Dpred.b.S12 + Dp2.b.S12*h.g[i,m.g12]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mg[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # Match function:
Elam.g[i] <- mean( Match(lambda.g12)(Nbar.m1) )
  }

### 3) EXPECTED VALUE

EVgain.b <- pnorm(valuediff.b) * Elam.b * ( valuediff.b + Eeps(valuediff.b) )
EVgain.g <- pnorm(valuediff.g) * Elam.g * ( valuediff.g + Eeps(valuediff.g) )

### 4) INTERPOLATION

# Transformations:

valuediff.b <- as.vector( valuediff.b )
valuediff.g <- as.vector( valuediff.g )

surplus.b <- as.vector( valuediff.b + Eeps(valuediff.b) )
surplus.g <- as.vector( valuediff.g + Eeps(valuediff.g) )

# Approximation:

ipar.b.S12 <<- lm(EVgain.b ~ valuediff.b + I(valuediff.b^2) + I(valuediff.b^3) + h.b[,m.b12]
  + I(surplus.b*nosupply.b[,1]) + I(surplus.b*h.b[,m.b12]) + I(surplus.b*Xbar.Mb) )$coef
ipar.g.S12 <<- lm(EVgain.g ~ valuediff.g + I(valuediff.g^2) + I(valuediff.g^3) + h.g[,m.g12]
  + I(surplus.g*h.g[,m.g12]) + I(surplus.g*Xbar.Mg) )$coef

}                                                                # END



### INTERPOLATING FUNCTION

EV0hat.b.S12 <- function (w, h, Xbar.m, nosupl)  {
  valuediff <- as.vector( a.b12 + a1.b*(1.5 + B*1.6/(1-B)) + g.b*h[,p.b12]/(1-B*d) + w/(1-B) - 
    B*v.b[1 + ifelse(w==W.b[2], 1, 0) + ifelse(w==W.b[3], 2, 0)] )
  surplus   <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, valuediff^2, valuediff^3, h[,m.b12],
    surplus*nosupl[,1], surplus*h[,m.b12], surplus*Xbar.m)  %*% ipar.b.S12 + 
    B*v.b[1 + ifelse(w==W.b[2], 1, 0) + ifelse(w==W.b[3], 2, 0)]
  }

EV0hat.g.S12 <- function (w, h, Xbar.m, nosupl)  {
  valuediff <- as.vector( a.g12 + a1.g*(1.5 + B*1.6/(1-B)) + g.g*h[,p.g12]/(1-B*d) + w/(1-B) - 
    B*v.g[1 + as.numeric(w==W.g[2]) + 2*as.numeric(w==W.g[3])] )
  surplus   <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, valuediff^2, valuediff^3, h[,m.g12],
    surplus*h[,m.g12], surplus*Xbar.m)  %*% ipar.g.S12 + 
    B*v.g[1 + as.numeric(w==W.g[2]) + 2*as.numeric(w==W.g[3])]
  }
