### FUNCTION

Spr9 <- function() {

### 1) INDIVIDUAL DECISION

# Predicted h:

                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b9] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b9]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b9] <- Eh0.b[,p.b9] + 1/pop.Pb;           E2h.b <- psi.chg(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b10]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.chg(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b); E10h.b <- psi.chg(E9h.b); E11h.b <- psi.qtr(E10h.b)
E12h.b <- psi.ann(E8h.b)

                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g9] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g9]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g9] <- Eh0.g[,p.g9] + 1/pop.Pg;           E2h.g <- psi.chg(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.chg(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g); E10h.g <- psi.chg(E9h.g); E11h.g <- psi.qtr(E10h.g)
E12h.g <- psi.ann(E8h.g)

# Threshold:

valuediff.b <- W.b[k.b]/(1-B) + 
  (1+B)*a.b9 + sum(B^(2:5))*a.b10 + sum(B^(6:9))*a.b11 + sum(B^(10:12))*a.b12 + 
  a1.b*(sum(B^(0:12)*(3:15)) + B^13*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] + B*Eh.b[,p.b9] 
         + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] + B^5*E5h.b[,p.b10] 
         + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] + B^9*E9h.b[,p.b11] 
         + B^10*E10h.b[,p.b12] + B^11*E11h.b[,p.b12] + B^12*E12h.b[,p.b12]/(1-B*d) ) -
  B*EV0hat.b.U9(W.b[k.b], Eh0.b, Xbar.Mb, pop.Pb, nosupply.b) 

valuediff.g <- W.g[k.g]/(1-B) + 
  (1+B)*a.g9 + sum(B^(2:5))*a.g10 + sum(B^(6:9))*a.g11 + sum(B^(10:12))*a.g12 + 
  a1.g*(sum(B^(0:12)*(3:15)) + B^13*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] + B*Eh.g[,p.g9] 
         + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] + B^5*E5h.g[,p.g10] 
         + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] + B^9*E9h.g[,p.g11] 
         + B^10*E10h.g[,p.g12] + B^11*E11h.g[,p.g12] + B^12*E12h.g[,p.g12]/(1-B*d) ) -
  B*EV0hat.g.U9(W.g[k.g], Eh0.g, Xbar.Mg, pop.Pg, nosupply.g) 

### 2) SUPPLY

Elam.b <- numeric(Pts) + as.vector( Match(lambda.b9)(cbind(0,0) ) )
Elam.g <- numeric(Pts) + as.vector( Match(lambda.g9)(cbind(0,0,0) ) )

# Boys:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mb[i,1]; pop.m2 <- pop.Mb[i,2]; pop.m3 <- pop.Mb[i,3]
  Nbar.m1 <- 0; Nbar.m2 <- 0; Nbar.m3 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mb[[i]][[1]] %*% Dpred.g.S9 + Dp2.g.S9*h.b[i,m.b9[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mb[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # Match function:
Elam.b[i] <- mean( Match(lambda.b9)(cbind(Nbar.m1,Nbar.m3) ) ) 
  }

# Girls:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mg[i,1]; pop.m2 <- pop.Mg[i,2]; pop.m3 <- pop.Mg[i,3]
  Nbar.m1 <- 0; Nbar.m2 <- 0; Nbar.m3 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mg[[i]][[1]] %*% Dpred.b.S9 + Dp2.b.S9*h.g[i,m.g9[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mg[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # Match function:
Elam.g[i] <- mean( Match(lambda.g9)(cbind(Nbar.m1,Nbar.m2,Nbar.m3) ) )
  }

### 3) EXPECTED VALUE

# Just surplus, excluding BEV^{t+1}(0,h):

EVgain.b <- pnorm(valuediff.b) * Elam.b * ( valuediff.b + Eeps(valuediff.b) )
EVgain.g <- pnorm(valuediff.g) * Elam.g * ( valuediff.g + Eeps(valuediff.g) )

### 4) INTERPOLATION

# Transformations:

valuediff.b <- as.vector( valuediff.b )
valuediff.g <- as.vector( valuediff.g )

surplus.b <- valuediff.b + Eeps(valuediff.b)
surplus.g <- valuediff.g + Eeps(valuediff.g)

# Approximation:

ipar.b.S9 <<- lm(EVgain.b ~ valuediff.b + I(valuediff.b^2) + I(valuediff.b^3) + h.b[,m.b9]
  + I(surplus.b*nosupply.b[,2]) + I(surplus.b*h.b[,m.b9]) + I(surplus.b*Xbar.Mb) )$coef
ipar.g.S9 <<- lm(EVgain.g ~ valuediff.g + I(valuediff.g^2) + I(valuediff.g^3) + h.g[,m.g9]
  + I(surplus.g*nosupply.g) + I(surplus.g*h.g[,m.g9]) + I(surplus.g*Xbar.Mg) )$coef

}                                                                # END




### INTERPOLATING FUNCTION

EV0hat.b.S9 <- function (w, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b9] <- h.b[,p.b9]/pop.Pb + Eh.b[,p.b9]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b9] <- Eh0.b[,p.b9] + 1/pop.Pb;           E2h.b <- psi.chg(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b10] <- (h.b[,p.b9]+1)/pop.Pb + E4h.b[,p.b10]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.qtr(E4h.b); E6h.b <- psi.chg(E5h.b);  E7h.b <- psi.qtr(E6h.b)
E8h.b <- psi.ann(E4h.b); E9h.b <- psi.qtr(E8h.b); E10h.b <- psi.chg(E9h.b); E11h.b <- psi.qtr(E10h.b)
E12h.b <- psi.ann(E8h.b)
  BEV0 <- B*EV0hat.b.U9(w, Eh0.b, Xbar.m, pop.Pb, nosupl)
  valuediff <- as.vector(
    w/(1-B) + 
  (1+B)*a.b9 + sum(B^(2:5))*a.b10 + sum(B^(6:9))*a.b11 + sum(B^(10:12))*a.b12 + 
  a1.b*(sum(B^(0:12)*(3:15)) + B^13*16/(1-B))/10 +
  g.b * ( h.b[,p.b9] + B*Eh.b[,p.b9] 
         + B^2*E2h.b[,p.b10] + B^3*E3h.b[,p.b10] + B^4*E4h.b[,p.b10] + B^5*E5h.b[,p.b10] 
         + B^6*E6h.b[,p.b11] + B^7*E7h.b[,p.b11] + B^8*E8h.b[,p.b11] + B^9*E9h.b[,p.b11] 
         + B^10*E10h.b[,p.b12] + B^11*E11h.b[,p.b12] + B^12*E12h.b[,p.b12]/(1-B*d) ) - BEV0 ) 
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, valuediff^2, valuediff^3, h.b[,m.b9],
    surplus*nosupl[,2], surplus*h.b[,m.b9], surplus*Xbar.m)  %*% ipar.b.S9 + BEV0
  }

EV0hat.g.S9 <- function (w, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g9] <- h.g[,p.g9]/pop.Pg + Eh.g[,p.g9]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g9] <- Eh0.g[,p.g9] + 1/pop.Pg;           E2h.g <- psi.chg(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g10] <- (h.g[,p.g9]+1)/pop.Pg + E4h.g[,p.g10]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.qtr(E4h.g); E6h.g <- psi.chg(E5h.g);  E7h.g <- psi.qtr(E6h.g)
E8h.g <- psi.ann(E4h.g); E9h.g <- psi.qtr(E8h.g); E10h.g <- psi.chg(E9h.g); E11h.g <- psi.qtr(E10h.g)
E12h.g <- psi.ann(E8h.g)
  BEV0 <- B*EV0hat.g.U9(w, Eh0.g, Xbar.m, pop.Pg, nosupl)
  valuediff <- as.vector(
    w/(1-B) +
  (1+B)*a.g9 + sum(B^(2:5))*a.g10 + sum(B^(6:9))*a.g11 + sum(B^(10:12))*a.g12 + 
  a1.g*(sum(B^(0:12)*(3:15)) + B^13*16/(1-B))/10 +
  g.g * ( h.g[,p.g9] + B*Eh.g[,p.g9] 
         + B^2*E2h.g[,p.g10] + B^3*E3h.g[,p.g10] + B^4*E4h.g[,p.g10] + B^5*E5h.g[,p.g10] 
         + B^6*E6h.g[,p.g11] + B^7*E7h.g[,p.g11] + B^8*E8h.g[,p.g11] + B^9*E9h.g[,p.g11] 
         + B^10*E10h.g[,p.g12] + B^11*E11h.g[,p.g12] + B^12*E12h.g[,p.g12]/(1-B*d) ) - BEV0 ) 
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, valuediff^2, valuediff^3, h.g[,m.g9],
    surplus*nosupl, surplus*h.g[,m.g9], surplus*Xbar.m)  %*% ipar.g.S9 + BEV0
  }

