### FUNCTION

Fal12 <- function() {

### 1) INDIVIDUAL DECISION

# Predicted h:

                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b12] <- h.b[,p.b12]/pop.Pb + Eh.b[,p.b12]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b12] <- Eh0.b[,p.b12] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b)

                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g12] <- h.g[,p.g12]/pop.Pg + Eh.g[,p.g12]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g12] <- Eh0.g[,p.g12] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g)

# Threshold:

valuediff.b <- (1+B+B^2)*a.b12 + a1.b*(sum(B^(0:2)*(13:15)) + B^3*16/(1-B))/10 + W.b[k.b]/(1-B) + 
  g.b * (h.b[,p.b12] + B*Eh.b[,p.b12] + B^2*E2h.b[,p.b12]/(1-B*d)) - 
  B*EV0hat.b.W12(W.b[k.b], Eh0.b, Xbar.Mb, pop.Pb, nosupply.b) 

valuediff.g <- (1+B+B^2)*a.g12 + a1.g*(sum(B^(0:2)*(13:15)) + B^3*16/(1-B))/10 + W.g[k.g]/(1-B) + 
  g.g * (h.g[,p.g12] + B*Eh.g[,p.g12] + B^2*E2h.g[,p.g12]/(1-B*d)) -
  B*EV0hat.g.W12(W.g[k.g], Eh0.g, Xbar.Mg, pop.Pg, nosupply.g) 

### 2) SUPPLY

Elam.b <- numeric(Pts) + as.vector( Match(lambda.b12)(cbind(0,0) ) )
Elam.g <- numeric(Pts) + as.vector( Match(lambda.g12)(0) )

# Boys:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mb[i,1]; pop.m2 <- pop.Mb[i,2]; pop.m3 <- pop.Mb[i,3]
  Nbar.m1 <- 0; Nbar.m2 <- 0; Nbar.m3 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mb[[i]][[1]] %*% Dpred.g.F12 + Dp2.g.F12*h.b[i,m.b12[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mb[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # M2) Grade below:
if (pop.m2 > 0)  {
  # Probabilities:
Dpred.m2 <- aXiXj.Mb[[i]][[2]] %*% Dpred.g.F11 + Dp2.g.F11*h.b[i,m.b12[2]]
  # Simulations:
D.m2 <- ( as.vector(Dpred.m2) > unif.Mb[[i]][[2]] )
  # Supplies:
N.m2 <- colSums(D.m2, na.rm=TRUE)
Nbar.m2 <- N.m2/pop.m2
    }
  # Match function:
Elam.b[i] <- mean( Match(lambda.b12)(cbind(Nbar.m1,Nbar.m2) ) ) 
  }

# Girls:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mg[i,1]
  Nbar.m1 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mg[[i]][[1]] %*% Dpred.b.F12 + Dp2.b.F12*h.g[i,m.g12]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mg[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # Match function:
Elam.g[i] <- mean( Match(lambda.g12)(Nbar.m1) )
  }

### 3) EXPECTED VALUE

# Just surplus, excluding BEV^{t+1}(0,h):

EVgain.b <- pnorm(valuediff.b) * Elam.b * ( valuediff.b + Eeps(valuediff.b) )
EVgain.g <- pnorm(valuediff.g) * Elam.g * ( valuediff.g + Eeps(valuediff.g) )

### 4) INTERPOLATION

# Transformations:

valuediff.b <- as.vector( valuediff.b )
valuediff.g <- as.vector( valuediff.g )

surplus.b <- valuediff.b + Eeps(valuediff.b)
surplus.g <- valuediff.g + Eeps(valuediff.g)

# Approximation:

ipar.b.F12 <<- lm(EVgain.b ~ valuediff.b + h.b[,m.b12]
  + I(surplus.b*nosupply.b[,1]) + I(surplus.b*h.b[,m.b12]) + I(surplus.b*Xbar.Mb) )$coef
ipar.g.F12 <<- lm(EVgain.g ~ valuediff.g + h.g[,m.g12]
  + I(surplus.g*h.g[,m.g12]) + I(surplus.g*Xbar.Mg) )$coef

}                                                                # END



### INTERPOLATING FUNCTION

EV0hat.b.F12 <- function (w, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.qtr(h.b)
Eh0.b[,p.b12] <- h.b[,p.b12]/pop.Pb + Eh.b[,p.b12]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b12] <- Eh0.b[,p.b12] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b)
  BEV0 <-B*EV0hat.b.W12(w, Eh0.b, Xbar.m, pop.Pb, nosupl)
  valuediff <- as.vector(
   (1+B+B^2)*a.b12 + a1.b*(sum(B^(0:2)*(13:15)) + B^3*16/(1-B))/10 + w/(1-B) + 
    g.b * (h.b[,p.b12] + B*Eh.b[,p.b12] + B^2*E2h.b[,p.b12]/(1-B*d)) - BEV0 )
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, h.b[,m.b12],
    surplus*nosupl[,1], surplus*h.b[,m.b12], surplus*Xbar.m)  %*% ipar.b.F12 + BEV0
  }

EV0hat.g.F12 <- function (w, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.qtr(h.g)
Eh0.g[,p.g12] <- h.g[,p.g12]/pop.Pg + Eh.g[,p.g12]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g12] <- Eh0.g[,p.g12] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g)
  BEV0 <- B*EV0hat.g.W12(w, Eh0.g, Xbar.m, pop.Pg, nosupl)
  valuediff <- as.vector(
   (1+B+B^2)*a.g12 + a1.g*(sum(B^(0:2)*(13:15)) + B^3*16/(1-B))/10 + w/(1-B) + 
    g.g * (h.g[,p.g12] + B*Eh.g[,p.g12] + B^2*E2h.g[,p.g12]/(1-B*d)) - BEV0 )
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, h.g[,m.g12],
    surplus*h.g[,m.g12], surplus*Xbar.m)  %*% ipar.g.F12 + BEV0
  }

