
### FUNCTION

Sum10 <- function() {

### 1) INDIVIDUAL DECISION

# Predicted h:

                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b11] <- h.b[,p.b10]/pop.Pb + Eh.b[,p.b11]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b11] <- Eh0.b[,p.b11] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b11] <- (h.b[,p.b10]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.chg(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)

                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g11] <- h.g[,p.g10]/pop.Pg + Eh.g[,p.g11]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g11] <- Eh0.g[,p.g11] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g11] <- (h.g[,p.g10]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.chg(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)

# Threshold:

valuediff.b <- W.b[k.b]/(1-B) + 
  a.b10 + sum(B^(1:4))*a.b11 + sum(B^(5:7))*a.b12 + 
  a1.b*(sum(B^(0:7)*(8:15)) + B^8*16/(1-B))/10 +
  g.b * ( h.b[,p.b10] 
         + B*Eh.b[,p.b11] + B^2*E2h.b[,p.b11] + B^3*E3h.b[,p.b11] + B^4*E4h.b[,p.b11] 
         + B^5*E5h.b[,p.b12] + B^6*E6h.b[,p.b12] + B^7*E7h.b[,p.b12]/(1-B*d) ) - 
  B*EV0hat.b.F11(W.b[k.b], Eh0.b, Xbar.Mb, pop.Pb, nosupply.b) 

valuediff.g <- W.g[k.g]/(1-B) + 
  a.g10 + sum(B^(1:4))*a.g11 + sum(B^(5:7))*a.g12 + 
  a1.g*(sum(B^(0:7)*(8:15)) + B^8*16/(1-B))/10 +
  g.g * ( h.g[,p.g10] 
         + B*Eh.g[,p.g11] + B^2*E2h.g[,p.g11] + B^3*E3h.g[,p.g11] + B^4*E4h.g[,p.g11] 
         + B^5*E5h.g[,p.g12] + B^6*E6h.g[,p.g12] + B^7*E7h.g[,p.g12]/(1-B*d) ) -
  B*EV0hat.g.F11(W.g[k.g], Eh0.g, Xbar.Mg, pop.Pg, nosupply.g) 

### 2) SUPPLY

Elam.b <- numeric(Pts) + as.vector( Match(lambda.b10)(cbind(0,0,0) ) )
Elam.g <- numeric(Pts) + as.vector( Match(lambda.g10)(cbind(0,0,0) ) )

# Boys:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mb[i,1]; pop.m2 <- pop.Mb[i,2]; pop.m3 <- pop.Mb[i,3]
  Nbar.m1 <- 0; Nbar.m2 <- 0; Nbar.m3 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mb[[i]][[1]] %*% Dpred.g.U10 + Dp2.g.U10*h.b[i,m.b10[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mb[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # M2) Grade below:
if (pop.m2 > 0)  {
  # Probabilities:
Dpred.m2 <- aXiXj.Mb[[i]][[2]] %*% Dpred.g.U9 + Dp2.g.U9*h.b[i,m.b10[2]]
  # Simulations:
D.m2 <- ( as.vector(Dpred.m2) > unif.Mb[[i]][[2]] )
  # Supplies:
N.m2 <- colSums(D.m2, na.rm=TRUE)
Nbar.m2 <- N.m2/pop.m2
    }
  # M3) Grade above:
if (pop.m3 > 0)  {
  # Probabilities:
Dpred.m3 <- aXiXj.Mb[[i]][[3]] %*% Dpred.g.U11 + Dp2.g.U11*h.b[i,m.b10[3]]
  # Simulations:
D.m3 <- ( as.vector(Dpred.m3) > unif.Mb[[i]][[3]] )
  # Supplies:
N.m3 <- colSums(D.m3, na.rm=TRUE)
Nbar.m3 <- N.m3/pop.m3
    }
  # Match function:
Elam.b[i] <- mean( Match(lambda.b10)(cbind(Nbar.m1,Nbar.m2,Nbar.m3) ) ) 
  }

# Girls:

for (i in 1:Pts)  {
  pop.m1 <- pop.Mg[i,1]; pop.m2 <- pop.Mg[i,2]; pop.m3 <- pop.Mg[i,3]
  Nbar.m1 <- 0; Nbar.m2 <- 0; Nbar.m3 <- 0
  #
  # M1) Same grade:
if (pop.m1 > 0)  {
  # Probabilities:
Dpred.m1 <- aXiXj.Mg[[i]][[1]] %*% Dpred.b.U10 + Dp2.b.U10*h.g[i,m.g10[1]]
  # Simulations:
D.m1 <- ( as.vector(Dpred.m1) > unif.Mg[[i]][[1]] )
  # Supplies:
N.m1 <- colSums(D.m1, na.rm=TRUE)
Nbar.m1 <- N.m1/pop.m1
    }
  # M2) Grade above:
if (pop.m2 > 0)  {
  # Probabilities:
Dpred.m2 <- aXiXj.Mg[[i]][[2]] %*% Dpred.b.U11 + Dp2.b.U11*h.g[i,m.g10[2]]
  # Simulations:
D.m2 <- ( as.vector(Dpred.m2) > unif.Mg[[i]][[2]] )
  # Supplies:
N.m2 <- colSums(D.m2, na.rm=TRUE)
Nbar.m2 <- N.m2/pop.m2
    }
  # Match function:
Elam.g[i] <- mean( Match(lambda.g10)(cbind(Nbar.m1,Nbar.m2,Nbar.m3) ) )
  }

### 3) EXPECTED VALUE

# Just surplus, excluding BEV^{t+1}(0,h):

EVgain.b <- pnorm(valuediff.b) * Elam.b * ( valuediff.b + Eeps(valuediff.b) )
EVgain.g <- pnorm(valuediff.g) * Elam.g * ( valuediff.g + Eeps(valuediff.g) )

### 4) INTERPOLATION

# Transformations:

valuediff.b <- as.vector( valuediff.b )
valuediff.g <- as.vector( valuediff.g )

surplus.b <- valuediff.b + Eeps(valuediff.b)
surplus.g <- valuediff.g + Eeps(valuediff.g)

# Approximation:

ipar.b.U10 <<- lm(EVgain.b ~ valuediff.b + h.b[,m.b10]
  + I(surplus.b*nosupply.b) + I(surplus.b*h.b[,m.b10]) + I(surplus.b*Xbar.Mb) )$coef
ipar.g.U10 <<- lm(EVgain.g ~ valuediff.g + h.g[,m.g10]
  + I(surplus.g*nosupply.g) + I(surplus.g*h.g[,m.g10]) + I(surplus.g*Xbar.Mg) )$coef

}                                                                # END



### INTERPOLATING FUNCTION

EV0hat.b.U10 <- function (w, h.b, Xbar.m, pop.Pb, nosupl)  {
                Eh0.b <- Eh.b <- psi.chg(h.b)
Eh0.b[,p.b11] <- h.b[,p.b10]/pop.Pb + Eh.b[,p.b11]*(pop.Pb-1)/pop.Pb
Eh.b[,p.b11] <- Eh0.b[,p.b11] + 1/pop.Pb;           E2h.b <- psi.qtr(Eh.b);   E3h.b <- psi.qtr(E2h.b)
E4h.b <- psi.ann(h.b); E4h.b[,p.b11] <- (h.b[,p.b10]+1)/pop.Pb + E4h.b[,p.b11]*(pop.Pb-1)/pop.Pb
                         E5h.b <- psi.chg(E4h.b); E6h.b <- psi.qtr(E5h.b);  E7h.b <- psi.qtr(E6h.b)
  BEV0 <- B*EV0hat.b.F11(w, Eh0.b, Xbar.m, pop.Pb, nosupl)
  valuediff <- as.vector(
    w/(1-B) + 
    a.b10 + sum(B^(1:4))*a.b11 + sum(B^(5:7))*a.b12 + a1.b*(sum(B^(0:7)*(8:15)) + B^8*16/(1-B))/10 +
  g.b * ( h.b[,p.b10] 
         + B*Eh.b[,p.b11] + B^2*E2h.b[,p.b11] + B^3*E3h.b[,p.b11] + B^4*E4h.b[,p.b11] 
         + B^5*E5h.b[,p.b12] + B^6*E6h.b[,p.b12] + B^7*E7h.b[,p.b12]/(1-B*d) ) - BEV0 ) 
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, h.b[,m.b10],
    surplus*nosupl, surplus*h.b[,m.b10], surplus*Xbar.m)  %*% ipar.b.U10+ BEV0
  }

EV0hat.g.U10 <- function (w, h.g, Xbar.m, pop.Pg, nosupl)  {
                Eh0.g <- Eh.g <- psi.chg(h.g)
Eh0.g[,p.g11] <- h.g[,p.g10]/pop.Pg + Eh.g[,p.g11]*(pop.Pg-1)/pop.Pg
Eh.g[,p.g11] <- Eh0.g[,p.g11] + 1/pop.Pg;           E2h.g <- psi.qtr(Eh.g);   E3h.g <- psi.qtr(E2h.g)
E4h.g <- psi.ann(h.g); E4h.g[,p.g11] <- (h.g[,p.g10]+1)/pop.Pg + E4h.g[,p.g11]*(pop.Pg-1)/pop.Pg
                         E5h.g <- psi.chg(E4h.g); E6h.g <- psi.qtr(E5h.g);  E7h.g <- psi.qtr(E6h.g)
  BEV0 <- B*EV0hat.g.F11(w, Eh0.g, Xbar.m, pop.Pg, nosupl)
  valuediff <- as.vector(
    w/(1-B) +
    a.g10 + sum(B^(1:4))*a.g11 + sum(B^(5:7))*a.g12 + a1.g*(sum(B^(0:7)*(8:15)) + B^8*16/(1-B))/10 +
  g.g * ( h.g[,p.g10] 
         + B*Eh.g[,p.g11] + B^2*E2h.g[,p.g11] + B^3*E3h.g[,p.g11] + B^4*E4h.g[,p.g11] 
         + B^5*E5h.g[,p.g12] + B^6*E6h.g[,p.g12] + B^7*E7h.g[,p.g12]/(1-B*d) ) - BEV0 ) 
  surplus <- as.vector( valuediff + Eeps(valuediff) )
  cbind(1, valuediff, h.g[,m.g10],
    surplus*nosupl, surplus*h.g[,m.g10], surplus*Xbar.m)  %*% ipar.g.U10 + BEV0
  }

