# Draw solution points used for interpolation.



### DRAW INTERPOLATION POINTS

# Number of interpolation points:

Pts <- 1000

# Number of draws used to compute arrival rate:
# (per individual in the supply/competitor group)

S.lam <- 10

# Draw aggregate state:

h.b <- matrix(runif(Pts*8), Pts, 8)
h.g <- matrix(runif(Pts*8), Pts, 8)

# Draw individuals:
# (sampled w/out replacement)

boysamp  <- sample(boys[cohort[boys] > 7 & cohort[boys] < 11],  Pts)
girlsamp <- sample(girls[cohort[girls] > 7 & cohort[girls] < 11], Pts)
# (sample restriction on cohort is so all supply groups are available)

# Observable characteristics:

Xi.b <- as.matrix( data[boysamp, indvars] )
Xi.g <- as.matrix( data[girlsamp, indvars] )

# Peer group sizes:

pop.Pb <- pop_P[boysamp]; pop.Pg <- pop_P[girlsamp]

# Unobservables:

k.b <- sample(1:3, Pts, replace=TRUE)
k.g <- sample(1:3, Pts, replace=TRUE)



### SUPPLY GROUP INFORMATION
#  (Collect their observables and draw standardized unobservables.)

# Storage:

pop.Mb <- h.b[,m.b10]*0 ; pop.Mg <- h.g[,m.g10]*0

aXiXj.Mb <- as.list(1:Pts); aXiXj.Mg <- as.list(1:Pts)
Xbar.Mb <- Xi.b*0; Xbar.Mg <- Xi.g*0 
unif.Mb <- as.list(1:Pts); unif.Mg <- as.list(1:Pts)

# A) Boys

for (s in 1:Pts)  {
  #
aXiXj.Mb[[s]] <- list(NULL,NULL,NULL); unif.Mb[[s]] <- list(NULL,NULL,NULL)
  #
pop.Mb[s,] <- c(length(M1[[ boysamp[s] ]]), length(M2[[ boysamp[s] ]]), length(M3[[ boysamp[s] ]]) )
if (grd9sep[boysamp[s]] & cohort[boysamp[s]]==9 ) pop.Mb[s,3] <- 0
if (grd9sep[boysamp[s]] & cohort[boysamp[s]]==10) pop.Mb[s,2] <- 0
  #
  if (pop.Mb[s,1] > 0)  {
               pop <- pop.Mb[s,1]
 unif.Mb[[s]][[1]] <- matrix(runif(pop*S.lam), pop, S.lam)
aXiXj.Mb[[s]][[1]] <- cbind(1, as.matrix( data[M1[[ boysamp[s] ]], indvars] ), 
                        rbind( Xbar.pj[M1[[ boysamp[s] ]],] ) )
    }
  if (pop.Mb[s,2] > 0)  {
               pop <- pop.Mb[s,2]
 unif.Mb[[s]][[2]] <- matrix(runif(pop*S.lam), pop, S.lam)
aXiXj.Mb[[s]][[2]] <- cbind(1, as.matrix( data[M2[[ boysamp[s] ]], indvars] ), 
                        rbind( Xbar.pj[M2[[ boysamp[s] ]],] ) )
    }
  if (pop.Mb[s,3] > 0)  {
               pop <- pop.Mb[s,3]
 unif.Mb[[s]][[3]] <- matrix(runif(pop*S.lam), pop, S.lam)
aXiXj.Mb[[s]][[3]] <- cbind(1, as.matrix( data[M3[[ boysamp[s] ]], indvars] ), 
                        rbind( Xbar.pj[M3[[ boysamp[s] ]],] ) )
    }
  if (sum(pop.Mb[s,]) > 0)  {
Xbar.Mb[s,] <- colMeans( 
  rbind(aXiXj.Mb[[s]][[1]][,indvars], aXiXj.Mb[[s]][[2]][,indvars], aXiXj.Mb[[s]][[3]][,indvars]) )
    }
  }

# B) Girls

for (s in 1:Pts)  {
  #
aXiXj.Mg[[s]] <- list(NULL,NULL,NULL); unif.Mg[[s]] <- list(NULL,NULL,NULL)
  #
pop.Mg[s,] <- c(length(M1[[ girlsamp[s] ]]), length(M2[[ girlsamp[s] ]]) , length(M3[[ girlsamp[s] ]]) )
if (grd9sep[girlsamp[s]] & cohort[girlsamp[s]]==8 ) pop.Mg[s,3] <- 0
if (grd9sep[girlsamp[s]] & cohort[girlsamp[s]]==9 ) pop.Mg[s,2] <- 0
if (grd9sep[girlsamp[s]] & cohort[girlsamp[s]]==9 ) pop.Mg[s,3] <- 0
  #
  if (pop.Mg[s,1] > 0)  {
               pop <- pop.Mg[s,1]
 unif.Mg[[s]][[1]] <- matrix(runif(pop*S.lam), pop, S.lam)
aXiXj.Mg[[s]][[1]] <- cbind(1, as.matrix( data[M1[[ girlsamp[s] ]], indvars] ), 
                        rbind( Xbar.pj[M1[[ girlsamp[s] ]],] ) )
    }
  if (pop.Mg[s,2] > 0)  {
               pop <- pop.Mg[s,2]
 unif.Mg[[s]][[2]] <- matrix(runif(pop*S.lam), pop, S.lam)
aXiXj.Mg[[s]][[2]] <- cbind(1, as.matrix( data[M2[[ girlsamp[s] ]], indvars] ), 
                        rbind( Xbar.pj[M2[[ girlsamp[s] ]],] ) )
    }
  if (pop.Mg[s,3] > 0)  {
               pop <- pop.Mg[s,3]
 unif.Mg[[s]][[3]] <- matrix(runif(pop*S.lam), pop, S.lam)
aXiXj.Mg[[s]][[3]] <- cbind(1, as.matrix( data[M3[[ girlsamp[s] ]], indvars] ), 
                        rbind( Xbar.pj[M3[[ girlsamp[s] ]],] ) )
    }
  if (sum(pop.Mg[s,]) > 0)  {
Xbar.Mg[s,] <- colMeans( 
  rbind(aXiXj.Mg[[s]][[1]][,indvars], aXiXj.Mg[[s]][[2]][,indvars], aXiXj.Mg[[s]][[3]][,indvars]) )
    }
  }

# No supply indicators:

nosupply.b <- pop.Mb[,2:3]==0; mode(nosupply.b) <- "numeric"
nosupply.g <- pop.Mg[,2:3]==0; mode(nosupply.g) <- "numeric"

colSums(nosupply.b)
colSums(nosupply.g)



### COMPETITOR GROUP INFORMATION
#  (Collect their observables and draw standardized unobservables.)

# Storage:

pop.Cb <- h.b[,c.b10]*0 ; pop.Cg <- h.g[,c.g10]*0

unif.Cb <- as.list(1:Pts); unif.Cg <- as.list(1:Pts)

# A) Boys

for (s in 1:Pts)  {
  #
unif.Cb[[s]] <- list(NULL,NULL,NULL)
  #
pop.Cb[s,] <- c(length(C1[[ boysamp[s] ]]), length(C2[[ boysamp[s] ]]), length(C3[[ boysamp[s] ]]) )
if (grd9sep[boysamp[s]] & cohort[boysamp[s]]==9 ) pop.Cb[s,3] <- 0
if (grd9sep[boysamp[s]] & cohort[boysamp[s]]==10) pop.Cb[s,2] <- 0
  #
  if (pop.Cb[s,1] > 0)  {
               pop <- pop.Cb[s,1]
 unif.Cb[[s]][[1]] <- matrix(runif(pop*S.lam), pop, S.lam)
    }
  if (pop.Cb[s,2] > 0)  {
               pop <- pop.Cb[s,2]
 unif.Cb[[s]][[2]] <- matrix(runif(pop*S.lam), pop, S.lam)
    }
  if (pop.Cb[s,3] > 0)  {
               pop <- pop.Cb[s,3]
 unif.Cb[[s]][[3]] <- matrix(runif(pop*S.lam), pop, S.lam)
    }
  }

# B) Girls

for (s in 1:Pts)  {
  #
unif.Cg[[s]] <- list(NULL,NULL,NULL)
  #
pop.Cg[s,] <- c(length(C1[[ girlsamp[s] ]]), length(C2[[ girlsamp[s] ]]) , length(C3[[ girlsamp[s] ]]) )
if (grd9sep[girlsamp[s]] & cohort[girlsamp[s]]==8 ) pop.Cg[s,3] <- 0
if (grd9sep[girlsamp[s]] & cohort[girlsamp[s]]==9 ) pop.Cg[s,2] <- 0
if (grd9sep[girlsamp[s]] & cohort[girlsamp[s]]==9 ) pop.Cg[s,3] <- 0
  #
  if (pop.Cg[s,1] > 0)  {
               pop <- pop.Cg[s,1]
 unif.Cg[[s]][[1]] <- matrix(runif(pop*S.lam), pop, S.lam)
    }
  if (pop.Cg[s,2] > 0)  {
               pop <- pop.Cg[s,2]
 unif.Cg[[s]][[2]] <- matrix(runif(pop*S.lam), pop, S.lam)
    }
  if (pop.Cg[s,3] > 0)  {
               pop <- pop.Cg[s,3]
 unif.Cg[[s]][[3]] <- matrix(runif(pop*S.lam), pop, S.lam)
    }
  }

# No competitors indicators:

nocomp.b <- pop.Cb[,2:3]==0; mode(nocomp.b) <- "numeric"
nocomp.g <- pop.Cg[,2:3]==0; mode(nocomp.g) <- "numeric"

colSums(nocomp.b)
colSums(nocomp.g)



### SAVE

save.image("workingfile.RData")
